(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var ECMAScript = Package.ecmascript.ECMAScript;
var MongoInternals = Package.mongo.MongoInternals;
var Mongo = Package.mongo.Mongo;
var Random = Package.random.Random;
var check = Package.check.check;
var Match = Package.check.Match;
var _ = Package.underscore._;
var Accounts = Package['accounts-base'].Accounts;
var HTTP = Package.http.HTTP;
var HTTPInternals = Package.http.HTTPInternals;
var Identicon = Package['sandstorm-identicons'].Identicon;
var meteorInstall = Package.modules.meteorInstall;
var Buffer = Package.modules.Buffer;
var process = Package.modules.process;
var Symbol = Package['ecmascript-runtime'].Symbol;
var Map = Package['ecmascript-runtime'].Map;
var Set = Package['ecmascript-runtime'].Set;
var meteorBabelHelpers = Package['babel-runtime'].meteorBabelHelpers;
var Promise = Package.promise.Promise;

/* Package-scope variables */
var Packages, DevPackages, UserActions, Grains, RoleAssignments, Contacts, Sessions, SignupKeys, ActivityStats, DeleteStats, FileTokens, ApiTokens, ApiHosts, Notifications, ActivitySubscriptions, StatsTokens, Misc, Settings, Migrations, StaticAssets, AssetUploadTokens, Plans, AppIndex, KeybaseProfiles, FeatureKey, SetupSession, successfulReferralsCount, isAdmin, isAdminById, findAdminUserForToken, matchWildcardHost, makeWildcardHost, getWildcardOrigin, SandstormDb, appName;

var require = meteorInstall({"node_modules":{"meteor":{"sandstorm-db":{"db.js":["babel-runtime/helpers/typeof",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/sandstorm-db/db.js                                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});                          //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file defines the database schema.                                                                              //
                                                                                                                       //
// Useful for debugging: Set the env variable LOG_MONGO_QUERIES to have the server write every                         //
// query it makes, so you can see if it's doing queries too often, etc.                                                //
if (Meteor.isServer && process.env.LOG_MONGO_QUERIES) {                                                                // 21
  (function () {                                                                                                       // 21
    var oldFind = Mongo.Collection.prototype.find;                                                                     // 22
    Mongo.Collection.prototype.find = function () {                                                                    // 23
      console.log(this._prefix, arguments);                                                                            // 24
      return oldFind.apply(this, arguments);                                                                           // 25
    };                                                                                                                 // 26
  })();                                                                                                                // 21
}                                                                                                                      // 27
                                                                                                                       //
// Helper so that we don't have to if (Meteor.isServer) before declaring indexes.                                      //
if (Meteor.isServer) {                                                                                                 // 30
  Mongo.Collection.prototype.ensureIndexOnServer = Mongo.Collection.prototype._ensureIndex;                            // 31
} else {                                                                                                               // 32
  Mongo.Collection.prototype.ensureIndexOnServer = function () {};                                                     // 33
}                                                                                                                      // 34
                                                                                                                       //
// TODO(soon): Systematically go through this file and add ensureIndexOnServer() as needed.                            //
                                                                                                                       //
var collectionOptions = { defineMutationMethods: Meteor.isClient };                                                    // 38
// Set to `true` on the client so that method simulation works. Set to `false` on the server                           //
// so that we can be extra certain that all mutations must go through methods.                                         //
                                                                                                                       //
// Users = new Mongo.Collection("users");                                                                              //
// The users collection is special and can be accessed through `Meteor.users`.                                         //
// See https://docs.meteor.com/#/full/meteor_users.                                                                    //
//                                                                                                                     //
// There are two distinct types of entries in the users collection: identities and accounts. An                        //
// identity contains personal profile information and typically includes some intrinsic method for                     //
// authenticating as the owner of that information.                                                                    //
//                                                                                                                     //
// An account is an owner of app actions, grains, contacts, notifications, and payment info.                           //
// Each account can have multiple identities linked to it. To log in as an account you must first                      //
// authenticate as one of its linked identities.                                                                       //
//                                                                                                                     //
// Every user contains the following fields:                                                                           //
//   _id: Unique string ID. For accounts, this is random. For identities, this is the globally                         //
//        stable SHA-256 ID of this identity, hex-encoded.                                                             //
//   createdAt: Date when this entry was added to the collection.                                                      //
//   lastActive: Date of the user's most recent interaction with this Sandstorm server.                                //
//   services: Object containing login data used by Meteor authentication services.                                    //
//   expires: Date when this user should be deleted. Only present for demo users.                                      //
//   upgradedFromDemo: If present, the date when this user was upgraded from being a demo user.                        //
//                     TODO(cleanup): Unlike other dates in our database, this is stored as a number                   //
//                     rather than as a Date object. We should fix that.                                               //
//   appDemoId: If present and non-null, then the user is a demo user who arrived via an /appdemo/                     //
//              link. This field contains the app ID of the app that the user started out demoing.                     //
//              Unlike the `expires` field, this field is not cleared when the user upgrades from                      //
//              being a demo user.                                                                                     //
//   suspended: If this exists, this account/identity is supsended. Both accounts and identities                       //
//              can be suspended. After some amount of time, the user will be completely deleted                       //
//              and removed from the DB.                                                                               //
//              It is an object with fields:                                                                           //
//                voluntary: Boolean. This is true if the user initiated it. They will have the                        //
//                  chance to still login and reverse the suspension/deletion.                                         //
//                admin: The userId of the admin who suspended the account.                                            //
//                timestamp: Date object. When the suspension occurred.                                                //
//                willDelete: Boolean. If true, this account will be deleted after some time.                          //
//                                                                                                                     //
// Identity users additionally contain the following fields:                                                           //
//   profile: Object containing the data that will be shared with users and grains that come into                      //
//            contact with this identity. Includes the following fields:                                               //
//       service: String containing the name of this identity's authentication method.                                 //
//       name: String containing the chosen display name of the identity.                                              //
//       handle: String containing the identity's preferred handle.                                                    //
//       picture: _id into the StaticAssets table for the identity's picture. If not present,                          //
//                an identicon will be used.                                                                           //
//       pronoun: One of "male", "female", "neutral", or "robot".                                                      //
//   unverifiedEmail: If present, a string containing an email address specified by the user.                          //
//   referredBy: ID of the Account that referred this Identity.                                                        //
//                                                                                                                     //
// Account users additionally contain the following fields:                                                            //
//   loginIdentities: Array of identity objects, each of which may include the following fields.                       //
//       id: The globally-stable SHA-256 ID of this identity, hex-encoded.                                             //
//   nonloginIdentities: Array of identity objects, of the same form as `loginIdentities`. We use                      //
//                       a separate array here so that we can use a Mongo index to enforce the                         //
//                       invariant that an identity only be a login identity for a single account.                     //
//   primaryEmail: String containing this account's primary email address. Must be a verified adress                   //
//                 of one of this account's linked identities. Call SandstormDb.getUserEmails()                        //
//                 to do this checking automatically.                                                                  //
//   isAdmin: Boolean indicating whether this account is allowed to access the Sandstorm admin panel.                  //
//   signupKey: If this is an invited user, then this field contains their signup key.                                 //
//   signupNote: If the user was invited through a link, then this field contains the note that the                    //
//               inviter admin attached to the key.                                                                    //
//   signupEmail: If the user was invited by email, then this field contains the email address that                    //
//                the invite was sent to.                                                                              //
//   hasCompletedSignup: True if this account has confirmed its profile and agreed to this server's                    //
//                       terms of service.                                                                             //
//   plan: _id of an entry in the Plans table which determines the user's quota.                                       //
//   planBonus: {storage, compute, grains} bonus amounts to add to the user's plan. The payments                       //
//              module writes data here; we merely read it. Missing fields should be treated as                        //
//              zeroes. Does not yet include referral bonus, which is calculated separately.                           //
//              TODO(cleanup): Use for referral bonus too.                                                             //
//   storageUsage: Number of bytes this user is currently storing.                                                     //
//   payments: Object defined by payments module, if loaded.                                                           //
//   dailySentMailCount: Number of emails sent by this user today; used to limit spam.                                 //
//   accessRequests: Object containing the following fields; used to limit spam.                                       //
//       count: Number of "request access" emails during sent during the current interval.                             //
//       resetOn: Date when the count should be reset.                                                                 //
//   referredByComplete: ID of the Account that referred this Account. If this is set, we                              //
//                        stop writing new referredBy values onto Identities for this account.                         //
//   referredCompleteDate: The Date at which the completed referral occurred.                                          //
//   referredIdentityIds: List of Identity IDs that this Account has referred. This is used for                        //
//                        reliably determining which Identity's names are safe to display.                             //
//   experiments: Object where each field is an experiment that the user is in, and each value                         //
//           is the parameters for that experiment. Typically, the value simply names which                            //
//           experiment group which the user is in, where "control" is one group. If an experiment                     //
//           is not listed, then the user should not be considered at all for the purpose of that                      //
//           experiment. Each experiment may define a point in time where users not already in the                     //
//           experiment may be added to it and assigned to a group (for example, at user creation                      //
//           time). Current experiments:                                                                               //
//       firstTimeBillingPrompt: Value is "control" or "test". Users are assigned to groups at                         //
//               account creation on servers where billing is enabled (i.e. Oasis). Users in the                       //
//               test group will see a plan selection dialog and asked to make an explitic choice                      //
//               (possibly "free") before they can create grains (but not when opening someone                         //
//               else's shared grain). The goal of the experiment is to determine whether this                         //
//               prompt scares users away -- and also whether it increases paid signups.                               //
//   stashedOldUser: A complete copy of this user from before the accounts/identities migration.                       //
//                   TODO(cleanup): Delete this field once we're sure it's safe to do so.                              //
                                                                                                                       //
Meteor.users.ensureIndexOnServer("services.google.email", { sparse: 1 });                                              // 139
Meteor.users.ensureIndexOnServer("services.github.emails.email", { sparse: 1 });                                       // 140
Meteor.users.ensureIndexOnServer("services.email.email", { unique: 1, sparse: 1 });                                    // 141
Meteor.users.ensureIndexOnServer("loginIdentities.id", { unique: 1, sparse: 1 });                                      // 142
Meteor.users.ensureIndexOnServer("nonloginIdentities.id", { sparse: 1 });                                              // 143
Meteor.users.ensureIndexOnServer("services.google.id", { unique: 1, sparse: 1 });                                      // 144
Meteor.users.ensureIndexOnServer("services.github.id", { unique: 1, sparse: 1 });                                      // 145
Meteor.users.ensureIndexOnServer("suspended.willDelete", { sparse: 1 });                                               // 146
                                                                                                                       //
// TODO(cleanup): This index is obsolete; delete it.                                                                   //
Meteor.users.ensureIndexOnServer("identities.id", { unique: 1, sparse: 1 });                                           // 149
                                                                                                                       //
Packages = new Mongo.Collection("packages", collectionOptions);                                                        // 151
// Packages which are installed or downloading.                                                                        //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  128-bit prefix of SHA-256 hash of spk file, hex-encoded.                                                    //
//   status:  String.  One of "download", "verify", "unpack", "analyze", "ready", "failed", "delete"                   //
//   progress:  Float.  -1 = N/A, 0-1 = fractional progress (e.g. download percentage),                                //
//       >1 = download byte count.                                                                                     //
//   error:  If status is "failed", error message string.                                                              //
//   manifest:  If status is "ready", the package manifest.  See "Manifest" in package.capnp.                          //
//   appId:  If status is "ready", the application ID string.  Packages representing different                         //
//       versions of the same app have the same appId.  The spk tool defines the app ID format                         //
//       and can cryptographically verify that a package belongs to a particular app ID.                               //
//   shouldCleanup:  If true, a reference to this package was recently dropped, and the package                        //
//       collector should at some point check whether there are any other references and, if not,                      //
//       delete the package.                                                                                           //
//   url:  When status is "download", the URL from which the SPK can be obtained, if provided.                         //
//   isAutoUpdated: This package was downloaded as part of an auto-update. We shouldn't clean it up                    //
//     even if it has no users.                                                                                        //
//   authorPgpKeyFingerprint: Verified PGP key fingerprint (SHA-1, hex, all-caps) of the app                           //
//     packager.                                                                                                       //
                                                                                                                       //
DevPackages = new Mongo.Collection("devpackages", collectionOptions);                                                  // 173
// List of packages currently made available via the dev tools running on the local machine.                           //
// This is normally empty; the only time it is non-empty is when a developer is using the spk tool                     //
// on the local machine to publish an under-development app to this server. That should only ever                      //
// happen on developers' desktop machines.                                                                             //
//                                                                                                                     //
// While a dev package is published, it automatically appears as installed by every user of the                        //
// server, and it overrides all packages with the same application ID. If any instances of those                       //
// packages are currently open, they are killed and reset on publish.                                                  //
//                                                                                                                     //
// When the dev tool disconnects, the package is automatically unpublished, and any open instances                     //
// are again killed and refreshed.                                                                                     //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  The package ID string (as with Packages._id).                                                               //
//   appId: The app ID this package is intended to override (as with Packages.appId).                                  //
//   timestamp:  Time when the package was last updated. If this changes while the package is                          //
//     published, all running instances are reset. This is used e.g. to reset the app each time                        //
//     changes are made to the source code.                                                                            //
//   manifest:  The app's manifest, as with Packages.manifest.                                                         //
//   mountProc: True if the supervisor should mount /proc.                                                             //
                                                                                                                       //
UserActions = new Mongo.Collection("userActions", collectionOptions);                                                  // 195
// List of actions that each user has installed which create new grains.  Each app may install                         //
// some number of actions (usually, one).                                                                              //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  random                                                                                                      //
//   userId:  Account ID of the user who has installed this action.                                                    //
//   packageId:  Package used to run this action.                                                                      //
//   appId:  Same as Packages.findOne(packageId).appId; denormalized for searchability.                                //
//   appTitle:  Same as Packages.findOne(packageId).manifest.appTitle; denormalized so                                 //
//       that clients can access it without subscribing to the Packages collection.                                    //
//   appVersion:  Same as Packages.findOne(packageId).manifest.appVersion; denormalized for                            //
//       searchability.                                                                                                //
//   appMarketingVersion:  Human-readable presentation of the app version, e.g. "2.9.17"                               //
//   title: JSON-encoded LocalizedText title for this action, e.g.                                                     //
//       `{defaultText: "New Spreadsheet"}`.                                                                           //
//   nounPhrase: JSON-encoded LocalizedText describing what is created when this action is run.                        //
//   command:  Manifest.Command to run this action (see package.capnp).                                                //
                                                                                                                       //
Grains = new Mongo.Collection("grains", collectionOptions);                                                            // 214
// Grains belonging to users.                                                                                          //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  random                                                                                                      //
//   packageId:  _id of the package of which this grain is an instance.                                                //
//   packageSalt: If present, a random string that will used in session ID generation. This field                      //
//       is usually updated when `packageId` is updated, triggering automatic refreshes for                            //
//       clients with active sessions.                                                                                 //
//   appId:  Same as Packages.findOne(packageId).appId; denormalized for searchability.                                //
//   appVersion:  Same as Packages.findOne(packageId).manifest.appVersion; denormalized for                            //
//       searchability.                                                                                                //
//   userId: The _id of the account that owns this grain.                                                              //
//   identityId: The identity with which the owning account prefers to open this grain.                                //
//   title:  Human-readable string title, as chosen by the user.                                                       //
//   lastUsed:  Date when the grain was last used by a user.                                                           //
//   private: If true, then knowledge of `_id` does not suffice to open this grain.                                    //
//   cachedViewInfo: The JSON-encoded result of `UiView.getViewInfo()`, cached from the most recent                    //
//                   time a session to this grain was opened.                                                          //
//   trashed: If present, the Date when this grain was moved to the trash bin. Thirty days after                       //
//            this date, the grain will be automatically deleted.                                                      //
//   suspended: If true, the owner of this grain has been suspended. They will soon be deleted,                        //
//              so treat this grain the same as "trashed". It is denormalized out of Users for ease                    //
//              of querying.                                                                                           //
//   ownerSeenAllActivity: True if the owner has viewed the grain since the last activity event                        //
//       occurred. See also ApiTokenOwner.user.seenAllActivity.                                                        //
//   size: On-disk size of the grain in bytes.                                                                         //
//                                                                                                                     //
// The following fields *might* also exist. These are temporary hacks used to implement e-mail and                     //
// web publishing functionality without powerbox support; they will be replaced once the powerbox                      //
// is implemented.                                                                                                     //
//   publicId:  An id used to publicly identify this grain. Used e.g. to route incoming e-mail and                     //
//       web publishing. This field is initialized when first requested by the app.                                    //
                                                                                                                       //
RoleAssignments = new Mongo.Collection("roleAssignments", collectionOptions);                                          // 248
// *OBSOLETE* Before `user` was a variant of ApiTokenOwner, this collection was used to store edges                    //
// in the permissions sharing graph. This functionality has been subsumed by the ApiTokens                             //
// collection.                                                                                                         //
                                                                                                                       //
Contacts = new Mongo.Collection("contacts", collectionOptions);                                                        // 253
// Edges in the social graph.                                                                                          //
//                                                                                                                     //
// If Alice has Bob as a contact, then she is allowed to see Bob's profile information and Bob                         //
// will show up in her user-picker UI for actions like share-by-identity.                                              //
//                                                                                                                     //
// Contacts are not symmetric. Bob might be one of Alice's contacts even if Alice is not one of                        //
// Bob's.                                                                                                              //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id: random                                                                                                       //
//   ownerId: The accountId of the user account who owns this contact.                                                 //
//   petname: Human-readable label chosen by and only visible to the owner. Uniquely identifies                        //
//            the contact to the owner.                                                                                //
//   created: Date when this contact was created.                                                                      //
//   identityId: The `_id` of the user whose contact info this contains.                                               //
                                                                                                                       //
Sessions = new Mongo.Collection("sessions", collectionOptions);                                                        // 270
// UI sessions open to particular grains.  A new session is created each time a user opens a grain.                    //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  String generated as a SHA256 hash of the grain ID, the user ID, a salt generated by the                     //
//       client, and the grain's `packageSalt`.                                                                        //
//   grainId:  _id of the grain to which this session is connected.                                                    //
//   hostId: ID part of the hostname from which this grain is being served. I.e. this replaces the                     //
//       '*' in WILDCARD_HOST.                                                                                         //
//   tabId: Random value unique to the grain tab in which this session is displayed. Typically                         //
//       every session has a different `tabId`, but embedded sessions (including in the powerbox)                      //
//       have the same `tabId` as the outer session.                                                                   //
//   timestamp:  Time of last keep-alive message to this session.  Sessions time out after some                        //
//       period.                                                                                                       //
//   userId:  Account ID of the user who owns this session.                                                            //
//   identityId:  Identity ID of the user who owns this session.                                                       //
//   hashedToken: If the session is owned by an anonymous user, the _id of the entry in ApiTokens                      //
//       that was used to open it. Note that for old-style sharing (i.e. when !grain.private),                         //
//       anonymous users can get access without an API token and so neither userId nor hashedToken                     //
//       are present.                                                                                                  //
//   powerboxView: If present, this is a view that should be presented as part of a powerbox                           //
//       interaction.                                                                                                  //
//     offer: The webkey that corresponds to cap that was passed to the `offer` RPC.                                   //
//   viewInfo: The UiView.ViewInfo corresponding to the underlying UiSession. This isn't populated                     //
//       until newSession is called on the UiView.                                                                     //
//   permissions: The permissions for the current identity on this UiView. This isn't populated                        //
//       until newSession is called on the UiView.                                                                     //
//   hasLoaded: Marked as true by the proxy when the underlying UiSession has responded to its first                   //
//       request                                                                                                       //
                                                                                                                       //
SignupKeys = new Mongo.Collection("signupKeys", collectionOptions);                                                    // 300
// Invite keys which may be used by users to get access to Sandstorm.                                                  //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  random                                                                                                      //
//   used:  Boolean indicating whether this key has already been consumed.                                             //
//   note:  Text note assigned when creating key, to keep track of e.g. whom the key was for.                          //
//   email: If this key was sent as an email invite, the email address to which it was sent.                           //
                                                                                                                       //
ActivityStats = new Mongo.Collection("activityStats", collectionOptions);                                              // 309
// Contains usage statistics taken on a regular interval. Each entry is a data point.                                  //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   timestamp: Date when measurements were taken.                                                                     //
//   daily: Contains stats counts pertaining to the last day before the sample time.                                   //
//   weekly: Contains stats counts pertaining to the last seven days before the sample time.                           //
//   monthly: Contains stats counts pertaining to the last thirty days before the timestamp.                           //
//                                                                                                                     //
// Each of daily, weekly, and monthly contains:                                                                        //
//   activeUsers: The number of unique users who have used a grain on the server in the time                           //
//       interval. Only counts logged-in users.                                                                        //
//   demoUsers: Demo users.                                                                                            //
//   appDemoUsers: Users that came in through "app demo".                                                              //
//   activeGrains: The number of unique grains that have been used in the time interval.                               //
//   apps: An object indexed by app ID recording, for each app:                                                        //
//       owners: Number of unique owners of this app (counting only grains that still exist).                          //
//       sharedUsers: Number of users who have accessed other people's grains of this app (counting                    //
//         only grains that still exist).                                                                              //
//       grains: Number of active grains of this app (that still exist).                                               //
//       deleted: Number of non-demo grains of this app that were deleted.                                             //
//       demoed: Number of demo grains created and expired.                                                            //
//       appDemoUsers: Number of app demos initiated with this app.                                                    //
                                                                                                                       //
DeleteStats = new Mongo.Collection("deleteStats", collectionOptions);                                                  // 333
// Contains records of objects that were deleted, for stat-keeping purposes.                                           //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   type: "grain" or "user" or "demoGrain" or "demoUser" or "appDemoUser"                                             //
//   lastActive: Date of the user's or grain's last activity.                                                          //
//   appId: For type = "grain", the app ID of the grain. For type = "appDemoUser", the app ID they                     //
//     arrived to demo. For others, undefined.                                                                         //
                                                                                                                       //
FileTokens = new Mongo.Collection("fileTokens", collectionOptions);                                                    // 342
// Tokens corresponding to backup files that are currently stored on the server. A user receives                       //
// a token when they create a backup file (either by uploading it, or by backing up one of their                       //
// grains) and may use the token to read the file (either to download it, or to restore a new                          //
// grain from it).                                                                                                     //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       The unguessable token string.                                                                          //
//   name:      Suggested filename.                                                                                    //
//   timestamp: File creation time. Used to figure out when the token and file should be wiped.                        //
                                                                                                                       //
ApiTokens = new Mongo.Collection("apiTokens", collectionOptions);                                                      // 353
// Access tokens for APIs exported by apps.                                                                            //
//                                                                                                                     //
// Originally API tokens were only used by external users through the HTTP API endpoint. However,                      //
// now they are also used to implement SturdyRefs, not just held by external users, but also when                      //
// an app holds a SturdyRef to another app within the same server. See the various `save()`,                           //
// `restore()`, and `drop()` methods in `grain.capnp` (on `SandstormApi`, `AppPersistent`, and                         //
// `MainView`) -- the fields of type `Data` are API tokens.                                                            //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       A SHA-256 hash of the token, base64-encoded.                                                           //
//   grainId:   The grain servicing this API. (Not present if the API isn't serviced by a grain.)                      //
//   identityId: For UiView capabilities, this is the identity for which the view is attenuated.                       //
//              That is, the UiView's newSession() method will intersect the requested permissions                     //
//              with this identity's permissions before forwarding on to the underlying app. If                        //
//              `identityId` is not present, then no identity attenuation is applied, i.e. this is                     //
//              a raw UiView as implemented by the app. (The `roleAssignment` field, below, may                        //
//              still apply. For non-UiView capabilities, `identityId` is never present. Note that                     //
//              this is NOT the identity against which the `requiredPermissions` parameter of                          //
//              `SandstormApi.restore()` is checked; that would be `owner.grain.introducerIdentity`.                   //
//   accountId: For tokens where `identityId` is set, the `_id` (in the Users table) of the account                    //
//              that created the token.                                                                                //
//   roleAssignment: If this API token represents a UiView, this field contains a JSON-encoded                         //
//              Grain.ViewSharingLink.RoleAssignment representing the permissions it carries. These                    //
//              permissions will be intersected with those held by `identityId` when the view is                       //
//              opened.                                                                                                //
//   forSharing: If true, requests sent to the HTTP API endpoint with this token will be treated as                    //
//              anonymous rather than as directly associated with `identityId`. This has no effect                     //
//              on the permissions granted.                                                                            //
//   objectId:  If present, this token represents an arbitrary Cap'n Proto capability exported by                      //
//              the app or its supervisor (whereas without this it strictly represents UiView).                        //
//              sturdyRef is the JSON-encoded SupervisorObjectId (defined in `supervisor.capnp`).                      //
//              Note that if the SupervisorObjectId contains an AppObjectId, that field is                             //
//              treated as type AnyPointer, and so encoded as a raw Cap'n Proto message.                               //
//   frontendRef: If present, this token actually refers to an object implemented by the front-end,                    //
//              not a particular grain. (`grainId` and `identityId` are not set.) This is an object                    //
//              containing exactly one of the following fields:                                                        //
//       notificationHandle: A `Handle` for an ongoing notification, as returned by                                    //
//                           `NotificationTarget.addOngoing`. The value is an `_id` from the                           //
//                           `Notifications` collection.                                                               //
//       ipNetwork: An IpNetwork capability that is implemented by the frontend. Eventually, this                      //
//                  will be moved out of the frontend and into the backend, but we'll migrate the                      //
//                  database when that happens. This field contains the boolean true to signify that                   //
//                  it has been set.                                                                                   //
//       ipInterface: Ditto IpNetwork, except it's an IpInterface.                                                     //
//       emailVerifier: An EmailVerifier capability that is implemented by the frontend. The                           //
//                      value is an object containing the fields `id` and `services`. `id` is the                      //
//                      value returned by `EmailVerifier.getId()` and is used as part of a                             //
//                      powerbox query for matching verified emails. `services` is a                                   //
//                      list of names of identity providers that are trusted to verify addresses.                      //
//                      If `services` is omitted or falsy, all configured identity providers are                       //
//                      trusted. Note that a malicious user could specify invalid names in the                         //
//                      list; they should be ignored.                                                                  //
//       verifiedEmail: An VerifiedEmail capability that is implemented by the frontend.                               //
//                      An object containing `verifierId`, `tabId`, and `address`.                                     //
//       identity: An Identity capability. The field is the identity ID.                                               //
//   parentToken: If present, then this token represents exactly the capability represented by                         //
//              the ApiToken with _id = parentToken, except possibly (if it is a UiView) attenuated                    //
//              by `roleAssignment` (if present). To facilitate permissions computations, if the                       //
//              capability is a UiView, then `grainId` is set to the backing grain, `identityId`                       //
//              is set to the identity that shared the view, and `accountId` is set to the account                     //
//              that shared the view. Neither `objectId` nor `frontendRef` is present when                             //
//              `parentToken` is present.                                                                              //
//   petname:   Human-readable label for this access token, useful for identifying tokens for                          //
//              revocation. This should be displayed when visualizing incoming capabilities to                         //
//              the grain identified by `grainId`.                                                                     //
//   created:   Date when this token was created.                                                                      //
//   revoked:   If true, then this sturdyref has been revoked and can no longer be restored. It may                    //
//              become un-revoked in the future.                                                                       //
//   trashed:   If present, the Date when this token was moved to the trash bin. Thirty days after                     //
//              this date, the token will be automatically deleted.                                                    //
//   suspended: If true, the owner of this token has been suspended. They will soon be deleted,                        //
//              so treat this token the same as "trashed". It is denormalized out of Users for                         //
//              ease of querying.                                                                                      //
//   expires:   Optional expiration Date. If undefined, the token does not expire.                                     //
//   lastUsed:  Optional Date when this token was last used.                                                           //
//   owner:     A `ApiTokenOwner` (defined in `supervisor.capnp`, stored as a JSON object)                             //
//              as passed to the `save()` call that created this token. If not present, treat                          //
//              as `webkey` (the default for `ApiTokenOwner`).                                                         //
//   expiresIfUnused:                                                                                                  //
//              Optional Date after which the token, if it has not been used yet, expires.                             //
//              This field should be cleared on a token's first use.                                                   //
//   requirements: List of conditions which must hold for this token to be considered valid.                           //
//              Semantically, this list specifies the powers which were *used* to originally                           //
//              create the token. If any condition in the list becomes untrue, then the token must                     //
//              be considered revoked, and all live refs and sturdy refs obtained transitively                         //
//              through it must also become revoked. Each item is the JSON serialization of the                        //
//              `MembraneRequirement` structure defined in `supervisor.capnp`.                                         //
//   hasApiHost: If true, there is an entry in ApiHosts for this token, which will need to be                          //
//              cleaned up when the token is.                                                                          //
//                                                                                                                     //
// It is important to note that a token's owner and provider are independent from each other. To                       //
// illustrate, here is an approximate definition of ApiToken in pseudo Cap'n Proto schema language:                    //
//                                                                                                                     //
// struct ApiToken {                                                                                                   //
//   owner :ApiTokenOwner;                                                                                             //
//   provider :union {                                                                                                 //
//     grain :group {                                                                                                  //
//       grainId :Text;                                                                                                //
//       union {                                                                                                       //
//         uiView :group {                                                                                             //
//           identityId :Text;                                                                                         //
//           roleAssignment :RoleAssignment;                                                                           //
//           forSharing :Bool;                                                                                         //
//         }                                                                                                           //
//         objectId :SupervisorObjectId;                                                                               //
//       }                                                                                                             //
//     }                                                                                                               //
//     frontendRef :union {                                                                                            //
//       notificationHandle :Text;                                                                                     //
//       ipNetwork :Bool;                                                                                              //
//       ipInterface :Bool;                                                                                            //
//       emailVerifier :group {                                                                                        //
//         id :Text;                                                                                                   //
//         services :List(String);                                                                                     //
//       }                                                                                                             //
//       verifiedEmail :group {                                                                                        //
//         verifierId :Text;                                                                                           //
//         tabId :Text;                                                                                                //
//         address :Text;                                                                                              //
//       }                                                                                                             //
//       identity :Text;                                                                                               //
//     }                                                                                                               //
//     child :group {                                                                                                  //
//       parentToken :Text;                                                                                            //
//       union {                                                                                                       //
//         uiView :group {                                                                                             //
//           grainId :Text;                                                                                            //
//           identityId :Text;                                                                                         //
//           roleAssignment :RoleAssignment = (allAccess = ());                                                        //
//         }                                                                                                           //
//         other :Void;                                                                                                //
//       }                                                                                                             //
//     }                                                                                                               //
//   }                                                                                                                 //
//   requirements: List(Supervisor.MembraneRequirement);                                                               //
//   ...                                                                                                               //
// }                                                                                                                   //
                                                                                                                       //
ApiTokens.ensureIndexOnServer("grainId", { sparse: 1 });                                                               // 492
ApiTokens.ensureIndexOnServer("owner.user.identityId", { sparse: 1 });                                                 // 493
ApiTokens.ensureIndexOnServer("frontendRef.emailVerifier.id", { sparse: 1 });                                          // 494
                                                                                                                       //
ApiHosts = new Mongo.Collection("apiHosts", collectionOptions);                                                        // 496
// Allows defining some limited static behavior for an API host when accessed unauthenticated. This                    //
// mainly exists to allow backwards-compatibility with client applications that expect to be able                      //
// to probe an API host without authentication to determine capabilities such as DAV protocols                         //
// supported, before authenticating to perform real requests. An app can specify these properties                      //
// when creating an offerTemplate.                                                                                     //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:          apiHostIdHashForToken() of the corresponding API token.                                             //
//   hash2:        hash(hash(token)), aka hash(ApiToken._id). Used to allow ApiHosts to be cleaned                     //
//                 up when ApiTokens are deleted.                                                                      //
//   options:      Specifies how to respond to unauthenticated OPTIONS requests on this host.                          //
//                 This is an object containing fields:                                                                //
//     dav:        List of strings specifying DAV header `compliance-class`es, e.g. "1" or                             //
//                 "calendar-access". https://tools.ietf.org/html/rfc4918#section-10.1                                 //
//   resources:    Object mapping URL paths (including initial '/') to static HTTP responses to                        //
//                 give when those paths are accessed unauthenticated. Due to Mongo disliking '.'                      //
//                 and '$' in keys, these characters must be escaped as '\uFF0E' and '\uFF04'                          //
//                 (see SandstormDb.escapeMongoKey). Each value in this map is an object with                          //
//                 fields:                                                                                             //
//     type:       Content-Type.                                                                                       //
//     language:   Content-Language.                                                                                   //
//     encoding:   Content-Encoding.                                                                                   //
//     body:       Entity-body as a string or buffer.                                                                  //
                                                                                                                       //
Notifications = new Mongo.Collection("notifications", collectionOptions);                                              // 521
// Notifications for a user.                                                                                           //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:          random                                                                                              //
//   grainId:      The grain originating this notification, if any.                                                    //
//   userId:       Account ID of the user receiving the notification.                                                  //
//   text:         The JSON-ified LocalizedText to display in the notification.                                        //
//   isUnread:     Boolean indicating if this notification is unread.                                                  //
//   timestamp:    Date when this notification was last updated                                                        //
//   eventType:    If this notification is due to an activity event, this is the numeric index                         //
//                 of the event type on the grain's ViewInfo.                                                          //
//   count:        The number of times this exact event has repeated. Identical events are                             //
//                 aggregated by incrementing the count.                                                               //
//   initiatingIdentity: Identity ID of the user who initiated this notification.                                      //
//   initiatorAnonymous: True if the initiator is an anonymous user. If neither this nor                               //
//                 initiatingIdentity is present, the notification is not from a user.                                 //
//   path:         Path inside the grain to which the user should be directed if they click on                         //
//                 the notification.                                                                                   //
//   ongoing:      If present, this is an ongoing notification, and this field contains an                             //
//                 ApiToken referencing the `OngoingNotification` capability.                                          //
//   admin:        If present, this is a notification intended for an admin.                                           //
//     action:     If present, this is a (string) link that the notification should direct the                         //
//                 admin to.                                                                                           //
//     type:       The type of notification -- can be "reportStats", "cantRenewFeatureKey", or                         //
//                 "trialFeatureKeyExpired".                                                                           //
//   appUpdates:   If present, this is an app update notification. It is an object with the appIds                     //
//                 as keys.                                                                                            //
//     $appId:     The appId that has an outstanding update.                                                           //
//       packageId: The packageId that it will update to.                                                              //
//       name: The name of the app. (appTitle from package.manifest)                                                   //
//       version: The app's version number. (appVersion from package.manifest)                                         //
//       marketingVersion: String marketing version of this app. (appMarketingVersion from package.manifest)           //
//   referral:     If this boolean field is true, then treat this notification as a referral                           //
//                 notification. This causes text to be ignored, since we need custom logic.                           //
//   mailingListBonus: Like `referral`, but notify the user about the mailing list bonus. This is                      //
//                 a one-time notification only to Oasis users who existed when the bonus program                      //
//                 was implemented.                                                                                    //
                                                                                                                       //
ActivitySubscriptions = new Mongo.Collection("activitySubscriptions", collectionOptions);                              // 560
// Activity events to which a user is subscribed.                                                                      //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:          random                                                                                              //
//   identityId:   Who is subscribed.                                                                                  //
//   grainId:      Grain to which subscription applies.                                                                //
//   threadPath:   If present, the subscription is on a specific thread. Otherwise, it is on the                       //
//                 whole grain.                                                                                        //
//   mute:         If true, this is an anti-subscription -- matching events should NOT notify.                         //
//                 This allows is useful to express:                                                                   //
//                 - A user wants to subscribe to a grain but mute a specific thread.                                  //
//                 - The owner of a grain does not want notifications (normally, they are                              //
//                   implicitly subscribed).                                                                           //
//                 - A user no longer wishes to be implicitly subscribed to threads in a grain on                      //
//                   which they comment, so they mute the grain.                                                       //
                                                                                                                       //
ActivitySubscriptions.ensureIndexOnServer("identityId");                                                               // 577
ActivitySubscriptions.ensureIndexOnServer({ "grainId": 1, "threadPath": 1 });                                          // 578
                                                                                                                       //
StatsTokens = new Mongo.Collection("statsTokens", collectionOptions);                                                  // 580
// Access tokens for the Stats collection                                                                              //
//                                                                                                                     //
// These tokens are used for accessing the ActivityStats collection remotely                                           //
// (ie. from a dashboard webapp)                                                                                       //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       The token. At least 128 bits entropy (Random.id(22)).                                                  //
                                                                                                                       //
Misc = new Mongo.Collection("misc", collectionOptions);                                                                // 589
// Miscellaneous configuration and other settings                                                                      //
//                                                                                                                     //
// This table is currently only used for persisting BASE_URL from one session to the next,                             //
// but in general any miscellaneous settings should go in here                                                         //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       The name of the setting. eg. "BASE_URL"                                                                //
//   value:     The value of the setting.                                                                              //
                                                                                                                       //
Settings = new Mongo.Collection("settings", collectionOptions);                                                        // 599
// Settings for this Sandstorm instance go here. They are configured through the adminSettings                         //
// route. This collection differs from misc in that any admin user can update it through the admin                     //
// interface.                                                                                                          //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       The name of the setting. eg. "smtpConfig"                                                              //
//   value:     The value of the setting.                                                                              //
//   automaticallyReset: Sometimes the server needs to automatically reset a setting. When it does                     //
//                       so, it will also write an object to this field indicating why the reset was                   //
//                       needed. That object can have the following variants:                                          //
//       baseUrlChangedFrom: The reset was due to BASE_URL changing. This field contains a string                      //
//                           with the old BASE_URL.                                                                    //
//   preinstalledApps: A list of objects:                                                                              //
//     appId: The Packages.appId of the app to install                                                                 //
//     status: packageId                                                                                               //
//     packageId: The Packages._id of the app to install                                                               //
//                                                                                                                     //
//   potentially other fields that are unique to the setting                                                           //
                                                                                                                       //
Migrations = new Mongo.Collection("migrations", collectionOptions);                                                    // 619
// This table tracks which migrations we have applied to this instance.                                                //
// It contains a single entry:                                                                                         //
//   _id:       "migrations_applied"                                                                                   //
//   value:     The number of migrations this instance has successfully completed.                                     //
                                                                                                                       //
StaticAssets = new Mongo.Collection("staticAssets", collectionOptions);                                                // 625
// Collection of static assets served up from the Sandstorm server's "static" host. We only                            //
// support relatively small assets: under 1MB each.                                                                    //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       Random ID; will be used in the URL.                                                                    //
//   hash:      A base64-encoded SHA-256 hash of the data, used to de-dupe.                                            //
//   mimeType:  MIME type of the asset, suitable for Content-Type header.                                              //
//   encoding:  Either "gzip" or not present, suitable for Content-Encoding header.                                    //
//   content:   The asset content (byte buffer).                                                                       //
//   refcount:  Number of places where this asset's ID appears in the database. Since Mongo doesn't                    //
//       have transactions, this needs to bias towards over-counting; a backup GC could be used                        //
//       to catch leaked assets, although it's probably not a big deal in practice.                                    //
                                                                                                                       //
AssetUploadTokens = new Mongo.Collection("assetUploadTokens", collectionOptions);                                      // 639
// Collection of tokens representing a single-use permission to upload an asset, such as a new                         //
// profile picture.                                                                                                    //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       Random ID.                                                                                             //
//   purpose:   Contains one of the following, indicating how the asset is to be used:                                 //
//       profilePicture: Indicates that the upload is a new profile picture. Contains fields:                          //
//           userId: Account ID of user whose picture shall be replaced.                                               //
//           identityId: Which of the user's identities shall be updated.                                              //
//   expires:   Time when this token will go away if unused.                                                           //
                                                                                                                       //
Plans = new Mongo.Collection("plans", collectionOptions);                                                              // 651
// Subscription plans, which determine quota.                                                                          //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id: Plan ID, usually a short string like "free", "standard", "large", "mega", ...                                //
//   storage: Number of bytes this user is allowed to store.                                                           //
//   compute: Number of kilobyte-RAM-seconds this user is allowed to consume.                                          //
//   computeLabel: Label to display to the user describing this plan's compute units.                                  //
//   grains: Total number of grains this user can create (often `Infinity`).                                           //
//   price: Price per month in US cents.                                                                               //
//   hidden: If true, a user cannot switch to this plan, but some users may be on it and are                           //
//       allowed to switch away.                                                                                       //
//   title: Title from display purposes. If missing, default to capitalizing _id.                                      //
                                                                                                                       //
AppIndex = new Mongo.Collection("appIndex", collectionOptions);                                                        // 665
// A mirror of the data from the App Market index                                                                      //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id: the appId of the app                                                                                         //
//  The rest of the fields are defined in src/sandstorm/app-index/app-index.capnp:AppIndexForMarket                    //
                                                                                                                       //
KeybaseProfiles = new Mongo.Collection("keybaseProfiles", collectionOptions);                                          // 672
// Cache of Keybase profile information. The profile for a user is re-fetched every time a package                     //
// by that user is installed, as well as if the keybase profile is requested and not already                           //
// present for some reason.                                                                                            //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id: PGP key fingerprint (SHA-1, hex, all-caps)                                                                   //
//   displayName: Display name from Keybase. (NOT VERIFIED AT ALL.)                                                    //
//   handle: Keybase handle.                                                                                           //
//   proofs: The "proofs_summary.all" array from the Keybase lookup. See the non-existent Keybase                      //
//     docs for details. We also add a boolean "status" field to each proof indicating whether                         //
//     we have directly verified the proof ourselves. Its values may be "unverified" (Keybase                          //
//     returned this but we haven't checked it directly), "verified" (we verified the proof and it                     //
//     is valid), "invalid" (we checked the proof and it was definitely bogus), or "checking" (the                     //
//     server is currently actively checking this proof). Note that if a check fails due to network                    //
//     errors, the status goes back to "unverified".                                                                   //
//                                                                                                                     //
//     WARNING: Currently verification is NOT IMPLEMENTED, so all proofs will be "unverified"                          //
//       for now and we just trust Keybase.                                                                            //
                                                                                                                       //
FeatureKey = new Mongo.Collection("featureKey", collectionOptions);                                                    // 692
// Responsible for storing the current feature key that is active on the server.  Contains a single                    //
// document with two keys:                                                                                             //
//                                                                                                                     //
//   _id: "currentFeatureKey"                                                                                          //
//   value: the still-signed, binary-encoded feature key                                                               //
//          (a feature key with comments removed and base64 decoded)                                                   //
//   renewalProblem: If we tried to renew this feature key and failed, an object describing that                       //
//       failure. Includes exactly one of the following fields:                                                        //
//     noPaymentSource: True, indicating that the key could not be renewed because there was no                        //
//         payment source set for this key.                                                                            //
//     paymentFailed: String error message returned by our payment processor describing why they                       //
//         declined the charge.                                                                                        //
//     noSuchKey: True, indicating the key doesn't exist.                                                              //
//     revoked: True, indicating the key has been revoked.                                                             //
//     unknownResponse: String response text from the renewal API which wasn't recognized. Should                      //
//         be reported to Sandstorm.                                                                                   //
//     exception: String error message from an exception thrown by the renewal code. This usually                      //
//         indicates some sort of connectivity problem, so could be reported to the user as:                           //
//         "There was a problem reaching the feature key renewal server."                                              //
//                                                                                                                     //
// This is only intended to be visible on the server.                                                                  //
                                                                                                                       //
SetupSession = new Mongo.Collection("setupSession", collectionOptions);                                                // 715
// Responsible for storing information about setup sessions.  Contains a single document with three                    //
// keys:                                                                                                               //
//                                                                                                                     //
//   _id: "current-session"                                                                                            //
//   creationDate: Date object indicating when this session was created.                                               //
//   hashedSessionId: the sha256 of the secret session id that was returned to the client                              //
                                                                                                                       //
var DesktopNotifications = new Mongo.Collection("desktopNotifications", collectionOptions);                            // 723
// Responsible for very short-lived queueing of desktop notification information.                                      //
// Entries are removed when they are ~30 seconds old.  This collection is a bit                                        //
// odd in that it is intended primarily for edge-triggered communications, but                                         //
// Meteor's collections aren't really designed to support that organization.                                           //
// Fields for each :                                                                                                   //
//                                                                                                                     //
//   _id: String.  Used as the tag to coordinate notification merging between browser tabs.                            //
//   creationDate: Date object. indicating when this notification was posted.                                          //
//   userId: String. Account id to which this notification was published.                                              //
//   notificationId: String.  ID of the matching event in the Notifications table to dismiss if this                   //
//                            notification is activated.                                                               //
//   appActivity: Object with fields:                                                                                  //
//     user: Optional Object. Not present if this notification wasn't generated by a user. If                          //
//           present, it will have one of the following shapes:                                                        //
//       { anonymous: true } if this notification was generated by an anonymous user.  Otherwise:                      //
//       {                                                                                                             //
//         identityId: String  The user's identity ID.                                                                 //
//         name: String        The user's display name.                                                                //
//         avatarUrl: String   The URL for the user's profile picture.                                                 //
//       },                                                                                                            //
//     grainId: String,      Which grain this action took place on                                                     //
//     path: String,         The path of the notification.                                                             //
//     body: Util.LocalizedText,  The main body of the activity event.                                                 //
//     actionText: Util.LocalizedText, What action the user took, e.g.                                                 //
//                                     { defaultText: "added a comment" }                                              //
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 750
  Meteor.publish("credentials", function () {                                                                          // 751
    // Data needed for isSignedUp() and isAdmin() to work.                                                             //
                                                                                                                       //
    if (this.userId) {                                                                                                 // 754
      var db = this.connection.sandstormDb;                                                                            // 755
      return [Meteor.users.find({ _id: this.userId }, { fields: { signupKey: 1, isAdmin: 1, expires: 1, storageUsage: 1,
          plan: 1, planBonus: 1, hasCompletedSignup: 1, experiments: 1,                                                // 759
          referredIdentityIds: 1, cachedStorageQuota: 1, suspended: 1 } }), db.collections.plans.find()];              // 760
    } else {                                                                                                           // 763
      return [];                                                                                                       // 764
    }                                                                                                                  // 765
  });                                                                                                                  // 766
}                                                                                                                      // 767
                                                                                                                       //
var countReferrals = function countReferrals(user) {                                                                   // 769
  var referredIdentityIds = user.referredIdentityIds;                                                                  // 770
  return referredIdentityIds && referredIdentityIds.length || 0;                                                       // 771
};                                                                                                                     // 772
                                                                                                                       //
var calculateReferralBonus = function calculateReferralBonus(user) {                                                   // 774
  // This function returns an object of the form:                                                                      //
  //                                                                                                                   //
  // - {grains: 0, storage: 0}                                                                                         //
  //                                                                                                                   //
  // which are extra resources this account gets as part of participating in the referral                              //
  // program. (Storage is measured in bytes, as usual for plans.)                                                      //
                                                                                                                       //
  // TODO(cleanup): Consider moving referral bonus logic into Oasis payments module (since it's                        //
  //   payments-specific) and aggregating into `planBonus`.                                                            //
                                                                                                                       //
  // Authorization note: Only call this if accountId is the current user!                                              //
  var isPaid = user.plan && user.plan !== "free";                                                                      // 786
                                                                                                                       //
  successfulReferralsCount = countReferrals(user);                                                                     // 788
  if (isPaid) {                                                                                                        // 789
    var maxPaidStorageBonus = 30 * 1e9;                                                                                // 790
    return { grains: 0,                                                                                                // 791
      storage: Math.min(successfulReferralsCount * 2 * 1e9, maxPaidStorageBonus) };                                    // 792
  } else {                                                                                                             // 795
    var maxFreeStorageBonus = 2 * 1e9;                                                                                 // 796
    var bonus = {                                                                                                      // 797
      storage: Math.min(successfulReferralsCount * 50 * 1e6, maxFreeStorageBonus)                                      // 798
    };                                                                                                                 // 797
    if (successfulReferralsCount > 0) {                                                                                // 802
      bonus.grains = Infinity;                                                                                         // 803
    } else {                                                                                                           // 804
      bonus.grains = 0;                                                                                                // 805
    }                                                                                                                  // 806
                                                                                                                       //
    return bonus;                                                                                                      // 808
  }                                                                                                                    // 809
};                                                                                                                     // 810
                                                                                                                       //
isAdmin = function isAdmin() {                                                                                         // 812
  // Returns true if the user is the administrator.                                                                    //
                                                                                                                       //
  var user = Meteor.user();                                                                                            // 815
  if (user && user.isAdmin) {                                                                                          // 816
    return true;                                                                                                       // 817
  } else {                                                                                                             // 818
    return false;                                                                                                      // 819
  }                                                                                                                    // 820
};                                                                                                                     // 821
                                                                                                                       //
isAdminById = function isAdminById(id) {                                                                               // 823
  // Returns true if the user's id is the administrator.                                                               //
                                                                                                                       //
  var user = Meteor.users.findOne({ _id: id }, { fields: { isAdmin: 1 } });                                            // 826
  if (user && user.isAdmin) {                                                                                          // 827
    return true;                                                                                                       // 828
  } else {                                                                                                             // 829
    return false;                                                                                                      // 830
  }                                                                                                                    // 831
};                                                                                                                     // 832
                                                                                                                       //
findAdminUserForToken = function findAdminUserForToken(token) {                                                        // 834
  if (!token.requirements) {                                                                                           // 835
    return;                                                                                                            // 836
  }                                                                                                                    // 837
                                                                                                                       //
  var requirements = token.requirements.filter(function (requirement) {                                                // 839
    return "userIsAdmin" in requirement;                                                                               // 840
  });                                                                                                                  // 841
                                                                                                                       //
  if (requirements.length > 1) {                                                                                       // 843
    return;                                                                                                            // 844
  }                                                                                                                    // 845
                                                                                                                       //
  if (requirements.length === 0) {                                                                                     // 847
    return;                                                                                                            // 848
  }                                                                                                                    // 849
                                                                                                                       //
  return requirements[0].userIsAdmin;                                                                                  // 851
};                                                                                                                     // 852
                                                                                                                       //
var wildcardHost = Meteor.settings["public"].wildcardHost.toLowerCase().split("*");                                    // 854
                                                                                                                       //
if (wildcardHost.length != 2) {                                                                                        // 856
  throw new Error("Wildcard host must contain exactly one asterisk.");                                                 // 857
}                                                                                                                      // 858
                                                                                                                       //
matchWildcardHost = function matchWildcardHost(host) {                                                                 // 860
  // See if the hostname is a member of our wildcard. If so, extract the ID.                                           //
                                                                                                                       //
  // We remove everything after the first ":" character so that our                                                    //
  // comparison logic ignores port numbers.                                                                            //
  var prefix = wildcardHost[0];                                                                                        // 865
  var suffix = wildcardHost[1].split(":")[0];                                                                          // 866
  var hostSansPort = host.split(":")[0];                                                                               // 867
                                                                                                                       //
  if (hostSansPort.lastIndexOf(prefix, 0) >= 0 && hostSansPort.indexOf(suffix, -suffix.length) >= 0 && hostSansPort.length >= prefix.length + suffix.length) {
    var id = hostSansPort.slice(prefix.length, -suffix.length);                                                        // 872
    if (id.match(/^[-a-z0-9]*$/)) {                                                                                    // 873
      return id;                                                                                                       // 874
    }                                                                                                                  // 875
  }                                                                                                                    // 876
                                                                                                                       //
  return null;                                                                                                         // 878
};                                                                                                                     // 879
                                                                                                                       //
makeWildcardHost = function makeWildcardHost(id) {                                                                     // 881
  return wildcardHost[0] + id + wildcardHost[1];                                                                       // 882
};                                                                                                                     // 883
                                                                                                                       //
var isApiHostId = function isApiHostId(hostId) {                                                                       // 885
  if (hostId) {                                                                                                        // 886
    var split = hostId.split("-");                                                                                     // 887
    if (split[0] === "api") return split[1] || "*";                                                                    // 888
  }                                                                                                                    // 889
                                                                                                                       //
  return false;                                                                                                        // 891
};                                                                                                                     // 892
                                                                                                                       //
var isTokenSpecificHostId = function isTokenSpecificHostId(hostId) {                                                   // 894
  return hostId.lastIndexOf("api-", 0) === 0;                                                                          // 895
};                                                                                                                     // 896
                                                                                                                       //
var apiHostIdHashForToken = void 0;                                                                                    // 898
if (Meteor.isServer) {                                                                                                 // 899
  (function () {                                                                                                       // 899
    var Crypto = Npm.require("crypto");                                                                                // 900
    apiHostIdHashForToken = function apiHostIdHashForToken(token) {                                                    // 901
      // Given an API token, compute the host ID that must be used when requesting this token.                         //
                                                                                                                       //
      // We add a leading 'x' to the hash so that knowing the hostname alone is not sufficient to                      //
      // find the corresponding API token in the ApiTokens table (whose _id values are also hashes                     //
      // of tokens). This doesn't technically add any security, but helps prove that we don't have                     //
      // any bugs which would allow someone who knows only the hostname to access the app API.                         //
      return Crypto.createHash("sha256").update("x" + token).digest("hex").slice(0, 32);                               // 908
    };                                                                                                                 // 909
  })();                                                                                                                // 899
} else {                                                                                                               // 910
  apiHostIdHashForToken = function apiHostIdHashForToken(token) {                                                      // 911
    // Given an API token, compute the host ID that must be used when requesting this token.                           //
                                                                                                                       //
    // We add a leading 'x' to the hash so that knowing the hostname alone is not sufficient to                        //
    // find the corresponding API token in the ApiTokens table (whose _id values are also hashes                       //
    // of tokens). This doesn't technically add any security, but helps prove that we don't have                       //
    // any bugs which would allow someone who knows only the hostname to access the app API.                           //
    return SHA256("x" + token).slice(0, 32);                                                                           // 918
  };                                                                                                                   // 919
}                                                                                                                      // 920
                                                                                                                       //
var apiHostIdForToken = function apiHostIdForToken(token) {                                                            // 922
  return "api-" + apiHostIdHashForToken(token);                                                                        // 923
};                                                                                                                     // 924
                                                                                                                       //
var makeApiHost = function makeApiHost(token) {                                                                        // 926
  return makeWildcardHost(apiHostIdForToken(token));                                                                   // 927
};                                                                                                                     // 928
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 930
  (function () {                                                                                                       // 930
    var Url = Npm.require("url");                                                                                      // 931
    getWildcardOrigin = function getWildcardOrigin() {                                                                 // 932
      // The wildcard URL can be something like "foo-*-bar.example.com", but sometimes when we're                      //
      // trying to specify a pattern matching hostnames (say, a Content-Security-Policy directive),                    //
      // an astrisk is only allowed as the first character and must be followed by a period. So we need                //
      // "*.example.com" instead -- which matches more than we actually want, but is the best we can                   //
      // really do. We also add the protocol to the front (again, that's what CSP wants).                              //
                                                                                                                       //
      // TODO(cleanup): `protocol` is computed in other files, like proxy.js. Put it somewhere common.                 //
      var protocol = Url.parse(process.env.ROOT_URL).protocol;                                                         // 940
                                                                                                                       //
      var dotPos = wildcardHost[1].indexOf(".");                                                                       // 942
      if (dotPos < 0) {                                                                                                // 943
        return protocol + "//*";                                                                                       // 944
      } else {                                                                                                         // 945
        return protocol + "//*" + wildcardHost[1].slice(dotPos);                                                       // 946
      }                                                                                                                // 947
    };                                                                                                                 // 948
  })();                                                                                                                // 930
}                                                                                                                      // 949
                                                                                                                       //
SandstormDb = function SandstormDb(quotaManager) {                                                                     // 951
  // quotaManager is an object with the following method:                                                              //
  //   updateUserQuota: It is provided two arguments                                                                   //
  //     db: This SandstormDb object                                                                                   //
  //     user: A collections.users account object                                                                      //
  //   and returns a quota object:                                                                                     //
  //     storage: A number (can be Infinity)                                                                           //
  //     compute: A number (can be Infinity)                                                                           //
  //     grains: A number (can be Infinity)                                                                            //
                                                                                                                       //
  this.quotaManager = quotaManager;                                                                                    // 961
  this.collections = {                                                                                                 // 962
    // Direct access to underlying collections. DEPRECATED, but better than accessing the top-level                    //
    // collection globals directly.                                                                                    //
    //                                                                                                                 //
    // TODO(cleanup): Over time, we will provide methods covering each supported query and remove                      //
    //   direct access to the collections.                                                                             //
    users: Meteor.users,                                                                                               // 968
                                                                                                                       //
    packages: Packages,                                                                                                // 970
    devPackages: DevPackages,                                                                                          // 971
    userActions: UserActions,                                                                                          // 972
    grains: Grains,                                                                                                    // 973
    roleAssignments: RoleAssignments, // Deprecated, only used by the migration that eliminated it.                    // 974
    contacts: Contacts,                                                                                                // 975
    sessions: Sessions,                                                                                                // 976
    signupKeys: SignupKeys,                                                                                            // 977
    activityStats: ActivityStats,                                                                                      // 978
    deleteStats: DeleteStats,                                                                                          // 979
    fileTokens: FileTokens,                                                                                            // 980
    apiTokens: ApiTokens,                                                                                              // 981
    apiHosts: ApiHosts,                                                                                                // 982
    notifications: Notifications,                                                                                      // 983
    activitySubscriptions: ActivitySubscriptions,                                                                      // 984
    statsTokens: StatsTokens,                                                                                          // 985
    misc: Misc,                                                                                                        // 986
    settings: Settings,                                                                                                // 987
    migrations: Migrations,                                                                                            // 988
    staticAssets: StaticAssets,                                                                                        // 989
    assetUploadTokens: AssetUploadTokens,                                                                              // 990
    plans: Plans,                                                                                                      // 991
    appIndex: AppIndex,                                                                                                // 992
    keybaseProfiles: KeybaseProfiles,                                                                                  // 993
    featureKey: FeatureKey,                                                                                            // 994
    setupSession: SetupSession,                                                                                        // 995
    desktopNotifications: DesktopNotifications                                                                         // 996
  };                                                                                                                   // 962
};                                                                                                                     // 998
                                                                                                                       //
// TODO(cleanup): These methods should not be defined freestanding and should use collection                           //
//   objects created in SandstormDb's constructor rather than globals.                                                 //
                                                                                                                       //
_.extend(SandstormDb.prototype, {                                                                                      // 1003
  isAdmin: isAdmin,                                                                                                    // 1004
  isAdminById: isAdminById,                                                                                            // 1005
  findAdminUserForToken: findAdminUserForToken,                                                                        // 1006
  matchWildcardHost: matchWildcardHost,                                                                                // 1007
  makeWildcardHost: makeWildcardHost,                                                                                  // 1008
  isApiHostId: isApiHostId,                                                                                            // 1009
  isTokenSpecificHostId: isTokenSpecificHostId,                                                                        // 1010
  apiHostIdHashForToken: apiHostIdHashForToken,                                                                        // 1011
  apiHostIdForToken: apiHostIdForToken,                                                                                // 1012
  makeApiHost: makeApiHost,                                                                                            // 1013
  allowDevAccounts: function allowDevAccounts() {                                                                      // 1014
    var setting = this.collections.settings.findOne({ _id: "devAccounts" });                                           // 1015
    if (setting) {                                                                                                     // 1016
      return setting.value;                                                                                            // 1017
    } else {                                                                                                           // 1018
      return Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].allowDevAccounts;               // 1019
    }                                                                                                                  // 1021
  },                                                                                                                   // 1022
                                                                                                                       //
                                                                                                                       //
  roleAssignmentPattern: {                                                                                             // 1024
    none: Match.Optional(null),                                                                                        // 1025
    allAccess: Match.Optional(null),                                                                                   // 1026
    roleId: Match.Optional(Match.Integer),                                                                             // 1027
    addPermissions: Match.Optional([Boolean]),                                                                         // 1028
    removePermissions: Match.Optional([Boolean])                                                                       // 1029
  },                                                                                                                   // 1024
                                                                                                                       //
  isDemoUser: function isDemoUser() {                                                                                  // 1032
    // Returns true if this is a demo user.                                                                            //
                                                                                                                       //
    var user = Meteor.user();                                                                                          // 1035
    if (user && user.expires) {                                                                                        // 1036
      return true;                                                                                                     // 1037
    } else {                                                                                                           // 1038
      return false;                                                                                                    // 1039
    }                                                                                                                  // 1040
  },                                                                                                                   // 1041
  isSignedUp: function isSignedUp() {                                                                                  // 1043
    var user = Meteor.user();                                                                                          // 1044
    return this.isAccountSignedUp(user);                                                                               // 1045
  },                                                                                                                   // 1046
  isAccountSignedUp: function isAccountSignedUp(user) {                                                                // 1048
    // Returns true if the user has presented an invite key.                                                           //
                                                                                                                       //
    if (!user) return false; // not signed in                                                                          // 1051
                                                                                                                       //
    if (!user.loginIdentities) return false; // not an account                                                         // 1053
                                                                                                                       //
    if (user.expires) return false; // demo user.                                                                      // 1055
                                                                                                                       //
    if (Meteor.settings["public"].allowUninvited) return true; // all accounts qualify                                 // 1057
                                                                                                                       //
    if (user.signupKey) return true; // user is invited                                                                // 1059
                                                                                                                       //
    if (this.isUserInOrganization(user)) return true;                                                                  // 1061
                                                                                                                       //
    return false;                                                                                                      // 1063
  },                                                                                                                   // 1064
  isSignedUpOrDemo: function isSignedUpOrDemo() {                                                                      // 1066
    var user = Meteor.user();                                                                                          // 1067
    return this.isAccountSignedUpOrDemo(user);                                                                         // 1068
  },                                                                                                                   // 1069
  isAccountSignedUpOrDemo: function isAccountSignedUpOrDemo(user) {                                                    // 1071
    if (!user) return false; // not signed in                                                                          // 1072
                                                                                                                       //
    if (!user.loginIdentities) return false; // not an account                                                         // 1074
                                                                                                                       //
    if (user.expires) return true; // demo user.                                                                       // 1076
                                                                                                                       //
    if (Meteor.settings["public"].allowUninvited) return true; // all accounts qualify                                 // 1078
                                                                                                                       //
    if (user.signupKey) return true; // user is invited                                                                // 1080
                                                                                                                       //
    if (this.isUserInOrganization(user)) return true;                                                                  // 1082
                                                                                                                       //
    return false;                                                                                                      // 1084
  },                                                                                                                   // 1085
  isIdentityInOrganization: function isIdentityInOrganization(identity) {                                              // 1087
    if (!identity || !identity.services) {                                                                             // 1088
      return false;                                                                                                    // 1089
    }                                                                                                                  // 1090
                                                                                                                       //
    var orgMembership = this.getOrganizationMembership();                                                              // 1092
    var googleEnabled = orgMembership && orgMembership.google && orgMembership.google.enabled;                         // 1093
    var googleDomain = orgMembership && orgMembership.google && orgMembership.google.domain;                           // 1094
    var emailEnabled = orgMembership && orgMembership.emailToken && orgMembership.emailToken.enabled;                  // 1095
    var emailDomain = orgMembership && orgMembership.emailToken && orgMembership.emailToken.domain;                    // 1096
    var ldapEnabled = orgMembership && orgMembership.ldap && orgMembership.ldap.enabled;                               // 1097
    var samlEnabled = orgMembership && orgMembership.saml && orgMembership.saml.enabled;                               // 1098
    if (emailEnabled && emailDomain && identity.services.email) {                                                      // 1099
      if (identity.services.email.email.toLowerCase().split("@").pop() === emailDomain) {                              // 1100
        return true;                                                                                                   // 1101
      }                                                                                                                // 1102
    } else if (ldapEnabled && identity.services.ldap) {                                                                // 1103
      return true;                                                                                                     // 1104
    } else if (samlEnabled && identity.services.saml) {                                                                // 1105
      return true;                                                                                                     // 1106
    } else if (googleEnabled && googleDomain && identity.services.google && identity.services.google.hd) {             // 1107
      if (identity.services.google.hd.toLowerCase() === googleDomain) {                                                // 1108
        return true;                                                                                                   // 1109
      }                                                                                                                // 1110
    }                                                                                                                  // 1111
                                                                                                                       //
    return false;                                                                                                      // 1113
  },                                                                                                                   // 1114
  isUserInOrganization: function isUserInOrganization(user) {                                                          // 1116
    if (!this.isFeatureKeyValid()) {                                                                                   // 1117
      return false;                                                                                                    // 1118
    }                                                                                                                  // 1119
                                                                                                                       //
    for (var i = 0; i < user.loginIdentities.length; i++) {                                                            // 1121
      var identity = Meteor.users.findOne({ _id: user.loginIdentities[i].id });                                        // 1122
      if (this.isIdentityInOrganization(identity)) {                                                                   // 1123
        return true;                                                                                                   // 1124
      }                                                                                                                // 1125
    }                                                                                                                  // 1126
                                                                                                                       //
    return false;                                                                                                      // 1128
  }                                                                                                                    // 1129
});                                                                                                                    // 1003
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 1132
  (function () {                                                                                                       // 1132
    SandstormDb.prototype.getWildcardOrigin = getWildcardOrigin;                                                       // 1133
                                                                                                                       //
    var Crypto = Npm.require("crypto");                                                                                // 1135
    SandstormDb.prototype.removeApiTokens = function (query) {                                                         // 1136
      var _this2 = this;                                                                                               // 1136
                                                                                                                       //
      // Remove all API tokens matching the query, making sure to clean up ApiHosts as well.                           //
                                                                                                                       //
      this.collections.apiTokens.find(query).forEach(function (token) {                                                // 1139
        // Clean up ApiHosts for webkey tokens.                                                                        //
        if (token.hasApiHost) {                                                                                        // 1141
          var hash2 = Crypto.createHash("sha256").update(token._id).digest("base64");                                  // 1142
          _this2.collections.apiHosts.remove({ hash2: hash2 });                                                        // 1143
        }                                                                                                              // 1144
      });                                                                                                              // 1145
                                                                                                                       //
      this.collections.apiTokens.remove(query);                                                                        // 1147
    };                                                                                                                 // 1148
  })();                                                                                                                // 1132
}                                                                                                                      // 1149
                                                                                                                       //
// TODO(someday): clean this up.  Logic for building static asset urls on client and server                            //
// appears all over the codebase.                                                                                      //
var httpProtocol = void 0;                                                                                             // 1153
if (Meteor.isServer) {                                                                                                 // 1154
  var _Url = Npm.require("url");                                                                                       // 1155
  httpProtocol = _Url.parse(process.env.ROOT_URL).protocol;                                                            // 1156
} else {                                                                                                               // 1157
  httpProtocol = window.location.protocol;                                                                             // 1158
}                                                                                                                      // 1159
                                                                                                                       //
// =======================================================================================                             //
// Below this point are newly-written or refactored functions.                                                         //
                                                                                                                       //
_.extend(SandstormDb.prototype, {                                                                                      // 1164
  getUser: function getUser(userId) {                                                                                  // 1165
    check(userId, Match.OneOf(String, undefined, null));                                                               // 1166
    if (userId) {                                                                                                      // 1167
      return Meteor.users.findOne(userId);                                                                             // 1168
    }                                                                                                                  // 1169
  },                                                                                                                   // 1170
  getIdentity: function getIdentity(identityId) {                                                                      // 1172
    check(identityId, String);                                                                                         // 1173
    var identity = Meteor.users.findOne({ _id: identityId });                                                          // 1174
    if (identity) {                                                                                                    // 1175
      SandstormDb.fillInProfileDefaults(identity);                                                                     // 1176
      SandstormDb.fillInIntrinsicName(identity);                                                                       // 1177
      SandstormDb.fillInPictureUrl(identity);                                                                          // 1178
      return identity;                                                                                                 // 1179
    }                                                                                                                  // 1180
  },                                                                                                                   // 1181
  userHasIdentity: function userHasIdentity(userId, identityId) {                                                      // 1183
    check(userId, String);                                                                                             // 1184
    check(identityId, String);                                                                                         // 1185
                                                                                                                       //
    if (userId === identityId) return true;                                                                            // 1187
                                                                                                                       //
    var user = Meteor.users.findOne(userId);                                                                           // 1189
    return SandstormDb.getUserIdentityIds(user).indexOf(identityId) != -1;                                             // 1190
  },                                                                                                                   // 1191
  userGrains: function userGrains(userId, options) {                                                                   // 1193
    check(userId, Match.OneOf(String, undefined, null));                                                               // 1194
    check(options, Match.OneOf(undefined, null, { includeTrashOnly: Match.Optional(Boolean), includeTrash: Match.Optional(Boolean) }));
                                                                                                                       //
    var query = { userId: userId };                                                                                    // 1198
    if (options && options.includeTrashOnly) {                                                                         // 1199
      query.trashed = { $exists: true };                                                                               // 1200
    } else if (options && options.includeTrash) {                                                                      // 1201
      // Keep query as-is.                                                                                             //
    } else {                                                                                                           // 1203
        query.trashed = { $exists: false };                                                                            // 1204
      }                                                                                                                // 1205
                                                                                                                       //
    return this.collections.grains.find(query);                                                                        // 1207
  },                                                                                                                   // 1208
  currentUserGrains: function currentUserGrains(options) {                                                             // 1210
    return this.userGrains(Meteor.userId(), options);                                                                  // 1211
  },                                                                                                                   // 1212
  getGrain: function getGrain(grainId) {                                                                               // 1214
    check(grainId, String);                                                                                            // 1215
    return this.collections.grains.findOne(grainId);                                                                   // 1216
  },                                                                                                                   // 1217
  userApiTokens: function userApiTokens(userId, trashed) {                                                             // 1219
    check(userId, Match.OneOf(String, undefined, null));                                                               // 1220
    check(trashed, Match.OneOf(Boolean, undefined, null));                                                             // 1221
    var identityIds = SandstormDb.getUserIdentityIds(this.getUser(userId));                                            // 1222
    return this.collections.apiTokens.find({                                                                           // 1223
      "owner.user.identityId": { $in: identityIds },                                                                   // 1224
      trashed: { $exists: !!trashed }                                                                                  // 1225
    });                                                                                                                // 1223
  },                                                                                                                   // 1227
  currentUserApiTokens: function currentUserApiTokens(trashed) {                                                       // 1229
    return this.userApiTokens(Meteor.userId(), trashed);                                                               // 1230
  },                                                                                                                   // 1231
  userActions: function userActions(user) {                                                                            // 1233
    return this.collections.userActions.find({ userId: user });                                                        // 1234
  },                                                                                                                   // 1235
  currentUserActions: function currentUserActions() {                                                                  // 1237
    return this.userActions(Meteor.userId());                                                                          // 1238
  },                                                                                                                   // 1239
  iconSrcForPackage: function iconSrcForPackage(pkg, usage) {                                                          // 1241
    return Identicon.iconSrcForPackage(pkg, usage, httpProtocol + "//" + this.makeWildcardHost("static"));             // 1242
  },                                                                                                                   // 1243
  getDenormalizedGrainInfo: function getDenormalizedGrainInfo(grainId) {                                               // 1245
    var grain = this.getGrain(grainId);                                                                                // 1246
    var pkg = this.collections.packages.findOne(grain.packageId);                                                      // 1247
                                                                                                                       //
    if (!pkg) {                                                                                                        // 1249
      pkg = this.collections.devPackages.findOne(grain.packageId);                                                     // 1250
    }                                                                                                                  // 1251
                                                                                                                       //
    var appTitle = pkg && pkg.manifest && pkg.manifest.appTitle || { defaultText: "" };                                // 1253
    var grainInfo = { appTitle: appTitle };                                                                            // 1254
                                                                                                                       //
    if (pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.icons) {                                 // 1256
      var icons = pkg.manifest.metadata.icons;                                                                         // 1257
      grainInfo.icon = icons.grain || icons.appGrid;                                                                   // 1258
    }                                                                                                                  // 1259
                                                                                                                       //
    // Only provide an app ID if we have no icon asset to provide and need to offer an identicon.                      //
    if (!grainInfo.icon && pkg) {                                                                                      // 1262
      grainInfo.appId = pkg.appId;                                                                                     // 1263
    }                                                                                                                  // 1264
                                                                                                                       //
    return grainInfo;                                                                                                  // 1266
  },                                                                                                                   // 1267
  getPlan: function getPlan(id) {                                                                                      // 1269
    check(id, String);                                                                                                 // 1270
    var plan = this.collections.plans.findOne(id);                                                                     // 1271
    if (!plan) {                                                                                                       // 1272
      throw new Error("no such plan: " + id);                                                                          // 1273
    }                                                                                                                  // 1274
                                                                                                                       //
    return plan;                                                                                                       // 1276
  },                                                                                                                   // 1277
  listPlans: function listPlans() {                                                                                    // 1279
    return this.collections.plans.find({}, { sort: { price: 1 } });                                                    // 1280
  },                                                                                                                   // 1281
  getMyPlan: function getMyPlan() {                                                                                    // 1283
    var user = Meteor.user();                                                                                          // 1284
    return user && this.collections.plans.findOne(user.plan || "free");                                                // 1285
  },                                                                                                                   // 1286
  getMyReferralBonus: function getMyReferralBonus(user) {                                                              // 1288
    // This function is called from the server and from the client, similar to getMyPlan().                            //
    //                                                                                                                 //
    // The parameter may be omitted in which case the current user is assumed.                                         //
                                                                                                                       //
    return calculateReferralBonus(user || Meteor.user());                                                              // 1293
  },                                                                                                                   // 1294
  getMyUsage: function getMyUsage(user) {                                                                              // 1296
    user = user || Meteor.user();                                                                                      // 1297
    if (user && (Meteor.isServer || user.pseudoUsage)) {                                                               // 1298
      if (Meteor.isClient) {                                                                                           // 1299
        // Filled by pseudo-subscription to "getMyUsage". WARNING: The subscription is currently                       //
        // not reactive.                                                                                               //
        return user.pseudoUsage;                                                                                       // 1302
      } else {                                                                                                         // 1303
        return {                                                                                                       // 1304
          grains: this.collections.grains.find({ userId: user._id }).count(),                                          // 1305
          storage: user.storageUsage || 0,                                                                             // 1306
          compute: 0 };                                                                                                // 1307
      }                                                                                                                // 1309
    } else // not tracked yet                                                                                          // 1310
      {                                                                                                                // 1310
        return { grains: 0, storage: 0, compute: 0 };                                                                  // 1311
      }                                                                                                                // 1312
  },                                                                                                                   // 1313
  isUninvitedFreeUser: function isUninvitedFreeUser() {                                                                // 1315
    if (!Meteor.settings["public"].allowUninvited) return false;                                                       // 1316
                                                                                                                       //
    var user = Meteor.user();                                                                                          // 1318
    return user && !user.expires && (!user.plan || user.plan === "free");                                              // 1319
  },                                                                                                                   // 1320
  getSetting: function getSetting(name) {                                                                              // 1322
    var setting = this.collections.settings.findOne(name);                                                             // 1323
    return setting && setting.value;                                                                                   // 1324
  },                                                                                                                   // 1325
  getSettingWithFallback: function getSettingWithFallback(name, fallbackValue) {                                       // 1327
    var value = this.getSetting(name);                                                                                 // 1328
    if (value === undefined) {                                                                                         // 1329
      return fallbackValue;                                                                                            // 1330
    }                                                                                                                  // 1331
                                                                                                                       //
    return value;                                                                                                      // 1333
  },                                                                                                                   // 1334
  addUserActions: function addUserActions(userId, packageId, simulation) {                                             // 1336
    check(userId, String);                                                                                             // 1337
    check(packageId, String);                                                                                          // 1338
                                                                                                                       //
    var pack = this.collections.packages.findOne({ _id: packageId });                                                  // 1340
    if (pack) {                                                                                                        // 1341
      // Remove old versions.                                                                                          //
      var numRemoved = this.collections.userActions.remove({ userId: userId, appId: pack.appId });                     // 1343
                                                                                                                       //
      // Install new.                                                                                                  //
      var actions = pack.manifest.actions;                                                                             // 1346
      for (var i in actions) {                                                                                         // 1347
        var action = actions[i];                                                                                       // 1348
        if ("none" in action.input) {                                                                                  // 1349
          var userAction = {                                                                                           // 1350
            userId: userId,                                                                                            // 1351
            packageId: pack._id,                                                                                       // 1352
            appId: pack.appId,                                                                                         // 1353
            appTitle: pack.manifest.appTitle,                                                                          // 1354
            appMarketingVersion: pack.manifest.appMarketingVersion,                                                    // 1355
            appVersion: pack.manifest.appVersion,                                                                      // 1356
            title: action.title,                                                                                       // 1357
            nounPhrase: action.nounPhrase,                                                                             // 1358
            command: action.command                                                                                    // 1359
          };                                                                                                           // 1350
          this.collections.userActions.insert(userAction);                                                             // 1361
        } else {                                                                                                       // 1362
          // TODO(someday):  Implement actions with capability inputs.                                                 //
        }                                                                                                              // 1364
      }                                                                                                                // 1365
                                                                                                                       //
      if (numRemoved > 0 && !simulation) {                                                                             // 1367
        this.deleteUnusedPackages(pack.appId);                                                                         // 1368
      }                                                                                                                // 1369
    }                                                                                                                  // 1370
  },                                                                                                                   // 1371
  sendAdminNotification: function sendAdminNotification(type, action) {                                                // 1373
    Meteor.users.find({ isAdmin: true }, { fields: { _id: 1 } }).forEach(function (user) {                             // 1374
      Notifications.insert({                                                                                           // 1375
        admin: { action: action, type: type },                                                                         // 1376
        userId: user._id,                                                                                              // 1377
        timestamp: new Date(),                                                                                         // 1378
        isUnread: true                                                                                                 // 1379
      });                                                                                                              // 1375
    });                                                                                                                // 1381
  },                                                                                                                   // 1382
  getKeybaseProfile: function getKeybaseProfile(keyFingerprint) {                                                      // 1384
    return this.collections.keybaseProfiles.findOne(keyFingerprint) || {};                                             // 1385
  },                                                                                                                   // 1386
  getServerTitle: function getServerTitle() {                                                                          // 1388
    var setting = this.collections.settings.findOne({ _id: "serverTitle" });                                           // 1389
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1390
  },                                                                                                                   // 1391
  getSmtpConfig: function getSmtpConfig() {                                                                            // 1393
    var setting = this.collections.settings.findOne({ _id: "smtpConfig" });                                            // 1394
    return setting ? setting.value : undefined; // undefined if subscription is not ready.                             // 1395
  },                                                                                                                   // 1396
  getReturnAddress: function getReturnAddress() {                                                                      // 1398
    var config = this.getSmtpConfig();                                                                                 // 1399
    return config && config.returnAddress || ""; // empty if subscription is not ready.                                // 1400
  },                                                                                                                   // 1401
  getReturnAddressWithDisplayName: function getReturnAddressWithDisplayName(identityId) {                              // 1403
    check(identityId, String);                                                                                         // 1404
    var identity = this.getIdentity(identityId);                                                                       // 1405
    var displayName = identity.profile.name + " (via " + this.getServerTitle() + ")";                                  // 1406
                                                                                                                       //
    // First remove any instances of characters that cause trouble for SimpleSmtp. Ideally,                            //
    // we could escape such characters with a backslash, but that does not seem to help here.                          //
    var sanitized = displayName.replace(/"|<|>|\\|\r/g, "");                                                           // 1410
                                                                                                                       //
    return "\"" + sanitized + "\" <" + this.getReturnAddress() + ">";                                                  // 1412
  },                                                                                                                   // 1413
  getPrimaryEmail: function getPrimaryEmail(accountId, identityId) {                                                   // 1415
    check(accountId, String);                                                                                          // 1416
    check(identityId, String);                                                                                         // 1417
                                                                                                                       //
    var identity = this.getIdentity(identityId);                                                                       // 1419
    var senderEmails = SandstormDb.getVerifiedEmails(identity);                                                        // 1420
    var senderPrimaryEmail = _.findWhere(senderEmails, { primary: true });                                             // 1421
    var accountPrimaryEmailAddress = this.getUser(accountId).primaryEmail;                                             // 1422
    if (_.findWhere(senderEmails, { email: accountPrimaryEmailAddress })) {                                            // 1423
      return accountPrimaryEmailAddress;                                                                               // 1424
    } else if (senderPrimaryEmail) {                                                                                   // 1425
      return senderPrimaryEmail.email;                                                                                 // 1426
    } else {                                                                                                           // 1427
      return null;                                                                                                     // 1428
    }                                                                                                                  // 1429
  },                                                                                                                   // 1430
  incrementDailySentMailCount: function incrementDailySentMailCount(accountId) {                                       // 1432
    check(accountId, String);                                                                                          // 1433
                                                                                                                       //
    var DAILY_LIMIT = 50;                                                                                              // 1435
    var result = Meteor.users.findAndModify({                                                                          // 1436
      query: { _id: accountId },                                                                                       // 1437
      update: {                                                                                                        // 1438
        $inc: {                                                                                                        // 1439
          dailySentMailCount: 1                                                                                        // 1440
        }                                                                                                              // 1439
      },                                                                                                               // 1438
      fields: { dailySentMailCount: 1 }                                                                                // 1443
    });                                                                                                                // 1436
                                                                                                                       //
    if (!result.ok) {                                                                                                  // 1446
      throw new Error("Couldn't update daily sent mail count.");                                                       // 1447
    }                                                                                                                  // 1448
                                                                                                                       //
    var user = result.value;                                                                                           // 1450
    if (user.dailySentMailCount >= DAILY_LIMIT) {                                                                      // 1451
      throw new Error("Sorry, you've reached your e-mail sending limit for today. Currently, Sandstorm " + "limits each user to " + DAILY_LIMIT + " e-mails per day for spam control reasons. " + "Please feel free to contact us if this is a problem.");
    }                                                                                                                  // 1456
  },                                                                                                                   // 1457
  isFeatureKeyValid: function isFeatureKeyValid() {                                                                    // 1459
    var featureKey = this.currentFeatureKey();                                                                         // 1460
    return !!featureKey;                                                                                               // 1461
  },                                                                                                                   // 1462
  isFeatureKeyValidAndNotExpired: function isFeatureKeyValidAndNotExpired() {                                          // 1464
    var featureKey = this.currentFeatureKey();                                                                         // 1465
    return featureKey && parseInt(featureKey.expires) > Date.now() / 1000;                                             // 1466
  },                                                                                                                   // 1467
  isFeatureKeyOptedIntoStats: function isFeatureKeyOptedIntoStats() {                                                  // 1469
    var featureKey = this.currentFeatureKey();                                                                         // 1470
    return featureKey && featureKey.isTrial && parseInt(featureKey.issued) > 1472601600;                               // 1471
    // 1472601600 is 2016 Aug 31 in seconds since the epoch                                                            //
  },                                                                                                                   // 1473
  getLdapUrl: function getLdapUrl() {                                                                                  // 1475
    var setting = this.collections.settings.findOne({ _id: "ldapUrl" });                                               // 1476
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1477
  },                                                                                                                   // 1478
  getLdapBase: function getLdapBase() {                                                                                // 1480
    var setting = this.collections.settings.findOne({ _id: "ldapBase" });                                              // 1481
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1482
  },                                                                                                                   // 1483
  getLdapDnPattern: function getLdapDnPattern() {                                                                      // 1485
    var setting = this.collections.settings.findOne({ _id: "ldapDnPattern" });                                         // 1486
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1487
  },                                                                                                                   // 1488
  getLdapSearchUsername: function getLdapSearchUsername() {                                                            // 1490
    var setting = this.collections.settings.findOne({ _id: "ldapSearchUsername" });                                    // 1491
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1492
  },                                                                                                                   // 1493
  getLdapNameField: function getLdapNameField() {                                                                      // 1495
    var setting = this.collections.settings.findOne({ _id: "ldapNameField" });                                         // 1496
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1497
  },                                                                                                                   // 1498
  getLdapEmailField: function getLdapEmailField() {                                                                    // 1500
    var setting = this.collections.settings.findOne({ _id: "ldapEmailField" });                                        // 1501
    return setting ? setting.value : "mail";                                                                           // 1502
    // default to "mail". This setting was added later, and so could potentially be unset.                             //
  },                                                                                                                   // 1504
  getLdapExplicitDnSelected: function getLdapExplicitDnSelected() {                                                    // 1506
    var setting = this.collections.settings.findOne({ _id: "ldapExplicitDnSelected" });                                // 1507
    return setting && setting.value;                                                                                   // 1508
  },                                                                                                                   // 1509
  getLdapFilter: function getLdapFilter() {                                                                            // 1511
    var setting = this.collections.settings.findOne({ _id: "ldapFilter" });                                            // 1512
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1513
  },                                                                                                                   // 1514
  getLdapSearchBindDn: function getLdapSearchBindDn() {                                                                // 1516
    var setting = this.collections.settings.findOne({ _id: "ldapSearchBindDn" });                                      // 1517
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1518
  },                                                                                                                   // 1519
  getLdapSearchBindPassword: function getLdapSearchBindPassword() {                                                    // 1521
    var setting = this.collections.settings.findOne({ _id: "ldapSearchBindPassword" });                                // 1522
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1523
  },                                                                                                                   // 1524
  getOrganizationMembership: function getOrganizationMembership() {                                                    // 1526
    var setting = this.collections.settings.findOne({ _id: "organizationMembership" });                                // 1527
    return setting && setting.value;                                                                                   // 1528
  },                                                                                                                   // 1529
  getOrganizationEmailEnabled: function getOrganizationEmailEnabled() {                                                // 1531
    var membership = this.getOrganizationMembership();                                                                 // 1532
    return membership && membership.emailToken && membership.emailToken.enabled;                                       // 1533
  },                                                                                                                   // 1534
  getOrganizationEmailDomain: function getOrganizationEmailDomain() {                                                  // 1536
    var membership = this.getOrganizationMembership();                                                                 // 1537
    return membership && membership.emailToken && membership.emailToken.domain;                                        // 1538
  },                                                                                                                   // 1539
  getOrganizationGoogleEnabled: function getOrganizationGoogleEnabled() {                                              // 1541
    var membership = this.getOrganizationMembership();                                                                 // 1542
    return membership && membership.google && membership.google.enabled;                                               // 1543
  },                                                                                                                   // 1544
  getOrganizationGoogleDomain: function getOrganizationGoogleDomain() {                                                // 1546
    var membership = this.getOrganizationMembership();                                                                 // 1547
    return membership && membership.google && membership.google.domain;                                                // 1548
  },                                                                                                                   // 1549
  getOrganizationLdapEnabled: function getOrganizationLdapEnabled() {                                                  // 1551
    var membership = this.getOrganizationMembership();                                                                 // 1552
    return membership && membership.ldap && membership.ldap.enabled;                                                   // 1553
  },                                                                                                                   // 1554
  getOrganizationSamlEnabled: function getOrganizationSamlEnabled() {                                                  // 1556
    var membership = this.getOrganizationMembership();                                                                 // 1557
    return membership && membership.saml && membership.saml.enabled;                                                   // 1558
  },                                                                                                                   // 1559
  getOrganizationDisallowGuests: function getOrganizationDisallowGuests() {                                            // 1561
    return this.getOrganizationDisallowGuestsRaw() && this.isFeatureKeyValid();                                        // 1562
  },                                                                                                                   // 1563
  getOrganizationDisallowGuestsRaw: function getOrganizationDisallowGuestsRaw() {                                      // 1565
    var setting = this.collections.settings.findOne({ _id: "organizationSettings" });                                  // 1566
    return setting && setting.value && setting.value.disallowGuests;                                                   // 1567
  },                                                                                                                   // 1568
  getOrganizationShareContacts: function getOrganizationShareContacts() {                                              // 1570
    return this.getOrganizationShareContactsRaw() && this.isFeatureKeyValid();                                         // 1571
  },                                                                                                                   // 1572
  getOrganizationShareContactsRaw: function getOrganizationShareContactsRaw() {                                        // 1574
    var setting = this.collections.settings.findOne({ _id: "organizationSettings" });                                  // 1575
    if (!setting || !setting.value || setting.value.shareContacts === undefined) {                                     // 1576
      // default to true if undefined                                                                                  //
      return true;                                                                                                     // 1578
    } else {                                                                                                           // 1579
      return setting.value.shareContacts;                                                                              // 1580
    }                                                                                                                  // 1581
  },                                                                                                                   // 1582
  getSamlEntryPoint: function getSamlEntryPoint() {                                                                    // 1584
    var setting = this.collections.settings.findOne({ _id: "samlEntryPoint" });                                        // 1585
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1586
  },                                                                                                                   // 1587
  getSamlPublicCert: function getSamlPublicCert() {                                                                    // 1589
    var setting = this.collections.settings.findOne({ _id: "samlPublicCert" });                                        // 1590
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1591
  },                                                                                                                   // 1592
  getSamlEntityId: function getSamlEntityId() {                                                                        // 1594
    var setting = this.collections.settings.findOne({ _id: "samlEntityId" });                                          // 1595
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1596
  },                                                                                                                   // 1597
  getActivitySubscriptions: function getActivitySubscriptions(grainId, threadPath) {                                   // 1599
    return this.collections.activitySubscriptions.find({                                                               // 1600
      grainId: grainId,                                                                                                // 1601
      threadPath: threadPath || { $exists: false }                                                                     // 1602
    }, {                                                                                                               // 1600
      fields: { identityId: 1, mute: 1, _id: 0 }                                                                       // 1604
    }).fetch();                                                                                                        // 1603
  },                                                                                                                   // 1606
  subscribeToActivity: function subscribeToActivity(identityId, grainId, threadPath) {                                 // 1608
    // Subscribe the given identity to activity events with the given grainId and (optional)                           //
    // threadPath -- unless the identity has previously muted this grainId/threadPath, in which                        //
    // case do nothing.                                                                                                //
                                                                                                                       //
    var record = { identityId: identityId, grainId: grainId };                                                         // 1613
    if (threadPath) {                                                                                                  // 1614
      record.threadPath = threadPath;                                                                                  // 1615
    }                                                                                                                  // 1616
                                                                                                                       //
    // The $set here is redundant since an upsert automatically initializes a new record to contain                    //
    // the fields from the query, but if we try to do { $set: {} } Mongo throws an exception, and                      //
    // if we try to just pass {}, Mongo interprets it as "replace the record with an empty record".                    //
    // What a wonderful query language.                                                                                //
    this.collections.activitySubscriptions.upsert(record, { $set: record });                                           // 1622
  },                                                                                                                   // 1623
  muteActivity: function muteActivity(identityId, grainId, threadPath) {                                               // 1625
    // Mute notifications for the given identity originating from the given grainId and                                //
    // (optional) threadPath.                                                                                          //
                                                                                                                       //
    var record = { identityId: identityId, grainId: grainId };                                                         // 1629
    if (threadPath) {                                                                                                  // 1630
      record.threadPath = threadPath;                                                                                  // 1631
    }                                                                                                                  // 1632
                                                                                                                       //
    this.collections.activitySubscriptions.upsert(record, { $set: { mute: true } });                                   // 1634
  },                                                                                                                   // 1635
  updateAppIndex: function updateAppIndex() {                                                                          // 1637
    var _this3 = this;                                                                                                 // 1637
                                                                                                                       //
    var appUpdatesEnabledSetting = this.collections.settings.findOne({ _id: "appUpdatesEnabled" });                    // 1638
    var appUpdatesEnabled = appUpdatesEnabledSetting && appUpdatesEnabledSetting.value;                                // 1639
    if (!appUpdatesEnabled) {                                                                                          // 1640
      // It's much simpler to check appUpdatesEnabled here rather than reactively deactivate the                       //
      // timer that triggers this call.                                                                                //
      return;                                                                                                          // 1643
    }                                                                                                                  // 1644
                                                                                                                       //
    var appIndexUrl = this.collections.settings.findOne({ _id: "appIndexUrl" }).value;                                 // 1646
    var appIndex = this.collections.appIndex;                                                                          // 1647
    var data = HTTP.get(appIndexUrl + "/apps/index.json").data;                                                        // 1648
    var preinstalledAppIds = this.getAllPreinstalledAppIds();                                                          // 1649
    // We make sure to get all preinstalled appIds, even ones that are currently                                       //
    // downloading/failed.                                                                                             //
    data.apps.forEach(function (app) {                                                                                 // 1652
      app._id = app.appId;                                                                                             // 1653
                                                                                                                       //
      var oldApp = appIndex.findOne({ _id: app.appId });                                                               // 1655
      app.hasSentNotifications = false;                                                                                // 1656
      appIndex.upsert({ _id: app._id }, app);                                                                          // 1657
      var isAppPreinstalled = _.contains(preinstalledAppIds, app.appId);                                               // 1658
      if ((!oldApp || app.versionNumber > oldApp.versionNumber) && (_this3.collections.userActions.findOne({ appId: app.appId }) || isAppPreinstalled)) {
        var pack = _this3.collections.packages.findOne({ _id: app.packageId });                                        // 1662
        var url = appIndexUrl + "/packages/" + app.packageId;                                                          // 1663
        if (pack) {                                                                                                    // 1664
          if (pack.status === "ready") {                                                                               // 1665
            if (pack.appId && pack.appId !== app.appId) {                                                              // 1666
              console.error("app index returned app ID and package ID that don't match:", JSON.stringify(app));        // 1667
            } else {                                                                                                   // 1669
              _this3.sendAppUpdateNotifications(app.appId, app.packageId, app.name, app.versionNumber, app.version);   // 1670
              if (isAppPreinstalled) {                                                                                 // 1672
                _this3.setPreinstallAppAsReady(app.appId, app.packageId);                                              // 1673
              }                                                                                                        // 1674
            }                                                                                                          // 1675
          } else {                                                                                                     // 1676
            var result = _this3.collections.packages.findAndModify({                                                   // 1677
              query: { _id: app.packageId },                                                                           // 1678
              update: { $set: { isAutoUpdated: true } }                                                                // 1679
            });                                                                                                        // 1677
                                                                                                                       //
            if (!result.ok) {                                                                                          // 1682
              return;                                                                                                  // 1683
            }                                                                                                          // 1684
                                                                                                                       //
            var newPack = result.value;                                                                                // 1686
            if (newPack.status === "ready") {                                                                          // 1687
              // The package was marked as ready before we applied isAutoUpdated=true. We should send                  //
              // notifications ourselves to be sure there's no timing issue (sending more than one is                  //
              // fine, since it will de-dupe).                                                                         //
              if (pack.appId && pack.appId !== app.appId) {                                                            // 1691
                console.error("app index returned app ID and package ID that don't match:", JSON.stringify(app));      // 1692
              } else {                                                                                                 // 1694
                _this3.sendAppUpdateNotifications(app.appId, app.packageId, app.name, app.versionNumber, app.version);
                if (isAppPreinstalled) {                                                                               // 1697
                  _this3.setPreinstallAppAsReady(app.appId, app.packageId);                                            // 1698
                }                                                                                                      // 1699
              }                                                                                                        // 1700
            } else if (newPack.status === "failed") {                                                                  // 1701
              // If the package has failed, retry it                                                                   //
              _this3.startInstall(app.packageId, url, true, true);                                                     // 1703
            }                                                                                                          // 1704
          }                                                                                                            // 1705
        } else {                                                                                                       // 1706
          _this3.startInstall(app.packageId, url, false, true);                                                        // 1707
        }                                                                                                              // 1708
      }                                                                                                                // 1709
    });                                                                                                                // 1710
  },                                                                                                                   // 1711
  isPackagePreinstalled: function isPackagePreinstalled(packageId) {                                                   // 1713
    return this.collections.settings.find({ _id: "preinstalledApps", "value.packageId": packageId }).count() === 1;    // 1714
  },                                                                                                                   // 1715
  getAppIdForPreinstalledPackage: function getAppIdForPreinstalledPackage(packageId) {                                 // 1717
    var setting = this.collections.settings.findOne({ _id: "preinstalledApps", "value.packageId": packageId }, { fields: { "value.$": 1 } });
    // value.$ causes mongo to transform the result and only return the first matching element in                      //
    // the array                                                                                                       //
    return setting && setting.value && setting.value[0] && setting.value[0].appId;                                     // 1722
  },                                                                                                                   // 1723
  getPackageIdForPreinstalledApp: function getPackageIdForPreinstalledApp(appId) {                                     // 1725
    var setting = this.collections.settings.findOne({ _id: "preinstalledApps", "value.appId": appId }, { fields: { "value.$": 1 } });
    // value.$ causes mongo to transform the result and only return the first matching element in                      //
    // the array                                                                                                       //
    return setting && setting.value && setting.value[0] && setting.value[0].packageId;                                 // 1730
  },                                                                                                                   // 1731
  getReadyPreinstalledAppIds: function getReadyPreinstalledAppIds() {                                                  // 1733
    var setting = this.collections.settings.findOne({ _id: "preinstalledApps" });                                      // 1734
    var ret = setting && setting.value || [];                                                                          // 1735
    return _.chain(ret).filter(function (app) {                                                                        // 1736
      return app.status === "ready";                                                                                   // 1737
    }).map(function (app) {                                                                                            // 1737
      return app.appId;                                                                                                // 1738
    }).value();                                                                                                        // 1738
  },                                                                                                                   // 1740
  getAllPreinstalledAppIds: function getAllPreinstalledAppIds() {                                                      // 1742
    var setting = this.collections.settings.findOne({ _id: "preinstalledApps" });                                      // 1743
    var ret = setting && setting.value || [];                                                                          // 1744
    return _.map(ret, function (app) {                                                                                 // 1745
      return app.appId;                                                                                                // 1745
    });                                                                                                                // 1745
  },                                                                                                                   // 1746
  preinstallAppsForUser: function preinstallAppsForUser(userId) {                                                      // 1748
    var _this4 = this;                                                                                                 // 1748
                                                                                                                       //
    var appIds = this.getReadyPreinstalledAppIds();                                                                    // 1749
    appIds.forEach(function (appId) {                                                                                  // 1750
      try {                                                                                                            // 1751
        _this4.addUserActions(userId, _this4.getPackageIdForPreinstalledApp(appId));                                   // 1752
      } catch (e) {                                                                                                    // 1753
        console.error("failed to install app for user:", e);                                                           // 1754
      }                                                                                                                // 1755
    });                                                                                                                // 1756
  },                                                                                                                   // 1757
  setPreinstallAppAsDownloading: function setPreinstallAppAsDownloading(appId, packageId) {                            // 1759
    this.collections.settings.update({ _id: "preinstalledApps", "value.appId": appId, "value.packageId": packageId }, { $set: { "value.$.status": "downloading" } });
  },                                                                                                                   // 1763
  setPreinstallAppAsReady: function setPreinstallAppAsReady(appId, packageId) {                                        // 1765
    // This function both sets the appId as ready and updates the packageId for the given appId                        //
    // Setting the packageId is especially useful in installer.js, as it always ensures the                            //
    // latest installed package will be set as ready.                                                                  //
    this.collections.settings.update({ _id: "preinstalledApps", "value.appId": appId }, { $set: { "value.$.status": "ready", "value.$.packageId": packageId } });
  },                                                                                                                   // 1772
  ensureAppPreinstall: function ensureAppPreinstall(appId, packageId) {                                                // 1774
    check(appId, String);                                                                                              // 1775
    var appIndexUrl = this.collections.settings.findOne({ _id: "appIndexUrl" }).value;                                 // 1776
    var pack = this.collections.packages.findOne({ _id: packageId });                                                  // 1777
    var url = appIndexUrl + "/packages/" + packageId;                                                                  // 1778
    if (pack && pack.status === "ready") {                                                                             // 1779
      this.setPreinstallAppAsReady(appId, packageId);                                                                  // 1780
    } else if (pack && pack.status === "failed") {                                                                     // 1781
      this.setPreinstallAppAsDownloading(appId, packageId);                                                            // 1782
      this.startInstall(packageId, url, true, false);                                                                  // 1783
    } else {                                                                                                           // 1784
      this.setPreinstallAppAsDownloading(appId, packageId);                                                            // 1785
      this.startInstall(packageId, url, false, false);                                                                 // 1786
    }                                                                                                                  // 1787
  },                                                                                                                   // 1788
  setPreinstalledApps: function setPreinstalledApps(appAndPackageIds) {                                                // 1790
    var _this5 = this;                                                                                                 // 1790
                                                                                                                       //
    // appAndPackageIds: A List[Object] where each element has fields:                                                 //
    //     appId: The Packages.appId of the app to install                                                             //
    //     packageId: The Packages._id of the app to install                                                           //
    check(appAndPackageIds, [{ appId: String, packageId: String }]);                                                   // 1794
                                                                                                                       //
    // Start by clearing out the setting. We'll push appIds one by one to it                                           //
    this.collections.settings.upsert({ _id: "preinstalledApps" }, { $set: {                                            // 1797
        value: appAndPackageIds.map(function (data) {                                                                  // 1798
          return {                                                                                                     // 1799
            appId: data.appId,                                                                                         // 1800
            status: "notReady",                                                                                        // 1801
            packageId: data.packageId                                                                                  // 1802
          };                                                                                                           // 1799
        })                                                                                                             // 1804
      } });                                                                                                            // 1797
    appAndPackageIds.forEach(function (data) {                                                                         // 1806
      _this5.ensureAppPreinstall(data.appId, data.packageId);                                                          // 1807
    });                                                                                                                // 1808
  },                                                                                                                   // 1809
  getProductivitySuiteAppIds: function getProductivitySuiteAppIds() {                                                  // 1811
    return ["8aspz4sfjnp8u89000mh2v1xrdyx97ytn8hq71mdzv4p4d8n0n3h", // Davros                                          // 1812
    "h37dm17aa89yrd8zuqpdn36p6zntumtv08fjpu8a8zrte7q1cn60", // Etherpad                                                // 1814
    "vfnwptfn02ty21w715snyyczw0nqxkv3jvawcah10c6z7hj1hnu0", // Rocket.Chat                                             // 1815
    "m86q05rdvj14yvn78ghaxynqz7u2svw6rnttptxx49g1785cdv1h"];                                                           // 1816
  },                                                                                                                   // 1818
  // Wekan                                                                                                             //
  getSystemSuiteAppIds: function getSystemSuiteAppIds() {                                                              // 1820
    return ["s3u2xgmqwznz2n3apf30sm3gw1d85y029enw5pymx734cnk5n78h"];                                                   // 1821
  },                                                                                                                   // 1824
  // Collections                                                                                                       //
  isPreinstalledAppsReady: function isPreinstalledAppsReady() {                                                        // 1826
    var setting = this.collections.settings.findOne({ _id: "preinstalledApps" });                                      // 1827
    if (!setting || !setting.value) {                                                                                  // 1828
      return true;                                                                                                     // 1829
    }                                                                                                                  // 1830
                                                                                                                       //
    var packageIds = _.pluck(setting.value, "packageId");                                                              // 1832
    var readyApps = this.collections.packages.find({                                                                   // 1833
      _id: {                                                                                                           // 1834
        $in: packageIds                                                                                                // 1835
      },                                                                                                               // 1834
      status: "ready"                                                                                                  // 1837
    });                                                                                                                // 1833
    return readyApps.count() === packageIds.length;                                                                    // 1839
  },                                                                                                                   // 1840
  getBillingPromptUrl: function getBillingPromptUrl() {                                                                // 1842
    var setting = this.collections.settings.findOne({ _id: "billingPromptUrl" });                                      // 1843
    return setting && setting.value;                                                                                   // 1844
  },                                                                                                                   // 1845
  isReferralEnabled: function isReferralEnabled() {                                                                    // 1847
    // This function is a bit weird, in that we've transitioned from                                                   //
    // Meteor.settings.public.quotaEnabled to DB settings. For now,                                                    //
    // Meteor.settings.public.quotaEnabled implies bothisReferralEnabled and isQuotaEnabled are true.                  //
    return Meteor.settings["public"].quotaEnabled;                                                                     // 1851
  },                                                                                                                   // 1852
  isQuotaEnabled: function isQuotaEnabled() {                                                                          // 1854
    if (Meteor.settings["public"].quotaEnabled) return true;                                                           // 1855
                                                                                                                       //
    var setting = this.collections.settings.findOne({ _id: "quotaEnabled" });                                          // 1857
    return setting && setting.value && this.isFeatureKeyValid();                                                       // 1858
  },                                                                                                                   // 1859
  isQuotaLdapEnabled: function isQuotaLdapEnabled() {                                                                  // 1861
    var setting = this.collections.settings.findOne({ _id: "quotaLdapEnabled" });                                      // 1862
    return setting && setting.value && this.isFeatureKeyValid();                                                       // 1863
  },                                                                                                                   // 1864
  updateUserQuota: function updateUserQuota(user) {                                                                    // 1866
    if (this.quotaManager) {                                                                                           // 1867
      return this.quotaManager.updateUserQuota(this, user);                                                            // 1868
    }                                                                                                                  // 1869
  },                                                                                                                   // 1870
  getUserQuota: function getUserQuota(user) {                                                                          // 1872
    if (this.isQuotaLdapEnabled()) {                                                                                   // 1873
      return this.quotaManager.updateUserQuota(this, user);                                                            // 1874
    } else {                                                                                                           // 1875
      var plan = this.collections.plans.findOne(user.plan || "free");                                                  // 1876
      var referralBonus = calculateReferralBonus(user);                                                                // 1877
      var bonus = user.planBonus || {};                                                                                // 1878
      var userQuota = {                                                                                                // 1879
        storage: plan.storage + referralBonus.storage + (bonus.storage || 0),                                          // 1880
        grains: plan.grains + referralBonus.grains + (bonus.grains || 0),                                              // 1881
        compute: plan.compute + (bonus.compute || 0)                                                                   // 1882
      };                                                                                                               // 1879
      return userQuota;                                                                                                // 1884
    }                                                                                                                  // 1885
  },                                                                                                                   // 1886
  isUserOverQuota: function isUserOverQuota(user) {                                                                    // 1888
    // Return false if user has quota space remaining, true if it is full. When this returns true,                     //
    // we will not allow the user to create new grains, though they may be able to open existing ones                  //
    // which may still increase their storage usage.                                                                   //
    //                                                                                                                 //
    // (Actually returns a string which can be fed into `billingPrompt` as the reason.)                                //
                                                                                                                       //
    if (!this.isQuotaEnabled() || user.isAdmin) return false;                                                          // 1895
                                                                                                                       //
    var plan = this.getUserQuota(user);                                                                                // 1897
    if (plan.grains < Infinity) {                                                                                      // 1898
      var count = this.collections.grains.find({ userId: user._id }, { fields: {}, limit: plan.grains }).count();      // 1899
      if (count >= plan.grains) return "outOfGrains";                                                                  // 1901
    }                                                                                                                  // 1902
                                                                                                                       //
    return plan && user.storageUsage && user.storageUsage >= plan.storage && "outOfStorage";                           // 1904
  },                                                                                                                   // 1905
  isUserExcessivelyOverQuota: function isUserExcessivelyOverQuota(user) {                                              // 1907
    // Return true if user is so far over quota that we should prevent their existing grains from                      //
    // running at all.                                                                                                 //
    //                                                                                                                 //
    // (Actually returns a string which can be fed into `billingPrompt` as the reason.)                                //
                                                                                                                       //
    if (!this.isQuotaEnabled() || user.isAdmin) return false;                                                          // 1913
                                                                                                                       //
    var quota = this.getUserQuota(user);                                                                               // 1915
                                                                                                                       //
    // quota.grains = Infinity means unlimited grains. IEEE754 defines Infinity == Infinity.                           //
    if (quota.grains < Infinity) {                                                                                     // 1918
      var count = this.collections.grains.find({ userId: user._id }, { fields: {}, limit: quota.grains * 2 }).count();
      if (count >= quota.grains * 2) return "outOfGrains";                                                             // 1921
    }                                                                                                                  // 1922
                                                                                                                       //
    return quota && user.storageUsage && user.storageUsage >= quota.storage * 1.2 && "outOfStorage";                   // 1924
  },                                                                                                                   // 1925
  suspendIdentity: function suspendIdentity(userId, suspension) {                                                      // 1927
    check(userId, String);                                                                                             // 1928
    check(suspension, {                                                                                                // 1929
      timestamp: Date,                                                                                                 // 1930
      admin: Match.Optional(String),                                                                                   // 1931
      voluntary: Match.Optional(Boolean)                                                                               // 1932
    });                                                                                                                // 1929
                                                                                                                       //
    this.collections.users.update({ _id: userId }, { $set: { suspended: suspension } });                               // 1935
    this.collections.apiTokens.update({ "owner.user.identityId": userId }, { $set: { suspended: true } }, { multi: true });
  },                                                                                                                   // 1938
  unsuspendIdentity: function unsuspendIdentity(userId) {                                                              // 1940
    check(userId, String);                                                                                             // 1941
                                                                                                                       //
    this.collections.users.update({ _id: userId }, { $unset: { suspended: 1 } });                                      // 1943
    this.collections.apiTokens.update({ "owner.user.identityId": userId }, { $unset: { suspended: true } }, { multi: true });
  },                                                                                                                   // 1946
  suspendAccount: function suspendAccount(userId, byAdminUserId, willDelete) {                                         // 1948
    var _this6 = this;                                                                                                 // 1948
                                                                                                                       //
    check(userId, String);                                                                                             // 1949
    check(byAdminUserId, Match.OneOf(String, null, undefined));                                                        // 1950
    check(willDelete, Boolean);                                                                                        // 1951
                                                                                                                       //
    var user = this.collections.users.findOne({ _id: userId });                                                        // 1953
    var suspension = {                                                                                                 // 1954
      timestamp: new Date(),                                                                                           // 1955
      willDelete: willDelete || false                                                                                  // 1956
    };                                                                                                                 // 1954
    if (byAdminUserId) {                                                                                               // 1958
      suspension.admin = byAdminUserId;                                                                                // 1959
    } else {                                                                                                           // 1960
      suspension.voluntary = true;                                                                                     // 1961
    }                                                                                                                  // 1962
                                                                                                                       //
    this.collections.users.update({ _id: userId }, { $set: { suspended: suspension } });                               // 1964
    this.collections.grains.update({ userId: userId }, { $set: { suspended: true } }, { multi: true });                // 1965
                                                                                                                       //
    delete suspension.willDelete;                                                                                      // 1967
    // Only mark the parent account for deletion. This makes the query simpler later.                                  //
                                                                                                                       //
    user.loginIdentities.forEach(function (identity) {                                                                 // 1970
      _this6.suspendIdentity(identity.id, suspension);                                                                 // 1971
    });                                                                                                                // 1972
    user.nonloginIdentities.forEach(function (identity) {                                                              // 1973
      if (_this6.collections.users.find({ $or: [{ "loginIdentities.id": identity.id }, { "nonloginIdentities.id": identity.id }] }).count() === 1) {
        // Only suspend non-login identities that are unique to this account.                                          //
        _this6.suspendIdentity(identity.id, suspension);                                                               // 1979
      }                                                                                                                // 1980
    });                                                                                                                // 1981
                                                                                                                       //
    // Force logout this user                                                                                          //
    this.collections.users.update({ _id: userId }, { $unset: { "services.resume.loginTokens": 1 } });                  // 1984
    if (user && user.loginIdentities) {                                                                                // 1986
      user.loginIdentities.forEach(function (identity) {                                                               // 1987
        Meteor.users.update({ _id: identity.id }, { $unset: { "services.resume.loginTokens": 1 } });                   // 1988
      });                                                                                                              // 1989
    }                                                                                                                  // 1990
  },                                                                                                                   // 1991
  unsuspendAccount: function unsuspendAccount(userId) {                                                                // 1993
    var _this7 = this;                                                                                                 // 1993
                                                                                                                       //
    check(userId, String);                                                                                             // 1994
                                                                                                                       //
    var user = this.collections.users.findOne({ _id: userId });                                                        // 1996
    this.collections.users.update({ _id: userId }, { $unset: { suspended: 1 } });                                      // 1997
    this.collections.grains.update({ userId: userId }, { $unset: { suspended: 1 } }, { multi: true });                 // 1998
                                                                                                                       //
    user.loginIdentities.forEach(function (identity) {                                                                 // 2000
      _this7.unsuspendIdentity(identity.id);                                                                           // 2001
    });                                                                                                                // 2002
                                                                                                                       //
    user.nonloginIdentities.forEach(function (identity) {                                                              // 2004
      _this7.unsuspendIdentity(identity.id);                                                                           // 2005
    });                                                                                                                // 2006
  },                                                                                                                   // 2007
  deletePendingAccounts: function deletePendingAccounts(deletionCoolingOffTime, backend, cb) {                         // 2009
    var _this8 = this;                                                                                                 // 2009
                                                                                                                       //
    check(deletionCoolingOffTime, Number);                                                                             // 2010
                                                                                                                       //
    var queryDate = new Date(Date.now() - deletionCoolingOffTime);                                                     // 2012
    this.collections.users.find({                                                                                      // 2013
      "suspended.willDelete": true,                                                                                    // 2014
      "suspended.timestamp": { $lt: queryDate }                                                                        // 2015
    }).forEach(function (user) {                                                                                       // 2013
      if (cb) cb(_this8, user);                                                                                        // 2017
      _this8.deleteAccount(user._id, backend);                                                                         // 2018
    });                                                                                                                // 2019
  }                                                                                                                    // 2020
});                                                                                                                    // 1164
                                                                                                                       //
SandstormDb.escapeMongoKey = function (key) {                                                                          // 2023
  // This incredibly poor mechanism for escaping Mongo keys is recommended by the Mongo docs here:                     //
  //   https://docs.mongodb.org/manual/faq/developers/#dollar-sign-operator-escaping                                   //
  // and seems to be a de facto standard, for example:                                                                 //
  //   https://www.npmjs.com/package/mongo-key-escape                                                                  //
  return key.replace(".", "．").replace("$", "＄");                                                                      // 2028
};                                                                                                                     // 2029
                                                                                                                       //
var appNameFromPackage = function appNameFromPackage(packageObj) {                                                     // 2031
  // This function takes a Package object from Mongo and returns an                                                    //
  // app title.                                                                                                        //
  var manifest = packageObj.manifest;                                                                                  // 2034
  if (!manifest) return packageObj.appId || packageObj._id || "unknown";                                               // 2035
  var action = manifest.actions[0];                                                                                    // 2036
  appName = manifest.appTitle && manifest.appTitle.defaultText || appNameFromActionName(action.title.defaultText);     // 2037
  return appName;                                                                                                      // 2039
};                                                                                                                     // 2040
                                                                                                                       //
var appNameFromActionName = function appNameFromActionName(name) {                                                     // 2042
  // Hack: Historically we only had action titles, like "New Etherpad Document", not app                               //
  //   titles. But for this UI we want app titles. As a transitionary measure, try to                                  //
  //   derive the app title from the action title.                                                                     //
  // TODO(cleanup): Get rid of this once apps have real titles.                                                        //
  if (!name) {                                                                                                         // 2047
    return "(unnamed)";                                                                                                // 2048
  }                                                                                                                    // 2049
                                                                                                                       //
  if (name.lastIndexOf("New ", 0) === 0) {                                                                             // 2051
    name = name.slice(4);                                                                                              // 2052
  }                                                                                                                    // 2053
                                                                                                                       //
  if (name.lastIndexOf("Hacker CMS", 0) === 0) {                                                                       // 2055
    name = "Hacker CMS";                                                                                               // 2056
  } else {                                                                                                             // 2057
    var space = name.indexOf(" ");                                                                                     // 2058
    if (space > 0) {                                                                                                   // 2059
      name = name.slice(0, space);                                                                                     // 2060
    }                                                                                                                  // 2061
  }                                                                                                                    // 2062
                                                                                                                       //
  return name;                                                                                                         // 2064
};                                                                                                                     // 2065
                                                                                                                       //
var appShortDescriptionFromPackage = function appShortDescriptionFromPackage(pkg) {                                    // 2067
  return pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.shortDescription && pkg.manifest.metadata.shortDescription.defaultText;
};                                                                                                                     // 2071
                                                                                                                       //
var nounPhraseForActionAndAppTitle = function nounPhraseForActionAndAppTitle(action, appTitle) {                       // 2073
  // A hack to deal with legacy apps not including fields in their manifests.                                          //
  // I look forward to the day I can remove most of this code.                                                         //
  // Attempt to figure out the appropriate noun that this action will create.                                          //
  // Use an explicit noun phrase is one is available.  Apps should add these in the future.                            //
  if (action.nounPhrase) return action.nounPhrase.defaultText;                                                         // 2078
  // Otherwise, try to guess one from the structure of the action title field                                          //
  if (action.title && action.title.defaultText) {                                                                      // 2080
    var text = action.title.defaultText;                                                                               // 2081
    // Strip a leading "New "                                                                                          //
    if (text.lastIndexOf("New ", 0) === 0) {                                                                           // 2083
      var candidate = text.slice(4);                                                                                   // 2084
      // Strip a leading appname too, if provided                                                                      //
      if (candidate.lastIndexOf(appTitle, 0) === 0) {                                                                  // 2086
        var newCandidate = candidate.slice(appTitle.length);                                                           // 2087
        // Unless that leaves you with no noun, in which case, use "grain"                                             //
        if (newCandidate.length > 0) {                                                                                 // 2089
          return newCandidate.toLowerCase();                                                                           // 2090
        } else {                                                                                                       // 2091
          return "grain";                                                                                              // 2092
        }                                                                                                              // 2093
      }                                                                                                                // 2094
                                                                                                                       //
      return candidate.toLowerCase();                                                                                  // 2096
    }                                                                                                                  // 2097
    // Some other verb phrase was given.  Just use it verbatim, and hope the app author updates                        //
    // the package soon.                                                                                               //
    return text;                                                                                                       // 2100
  } else {                                                                                                             // 2101
    return "grain";                                                                                                    // 2102
  }                                                                                                                    // 2103
};                                                                                                                     // 2104
                                                                                                                       //
// Static methods on SandstormDb that don't need an instance.                                                          //
// Largely things that deal with backwards-compatibility.                                                              //
_.extend(SandstormDb, {                                                                                                // 2108
  appNameFromActionName: appNameFromActionName,                                                                        // 2109
  appNameFromPackage: appNameFromPackage,                                                                              // 2110
  appShortDescriptionFromPackage: appShortDescriptionFromPackage,                                                      // 2111
  nounPhraseForActionAndAppTitle: nounPhraseForActionAndAppTitle                                                       // 2112
});                                                                                                                    // 2108
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 2115
  (function () {                                                                                                       // 2115
    var Crypto = Npm.require("crypto");                                                                                // 2116
    var ContentType = Npm.require("content-type");                                                                     // 2117
    var Zlib = Npm.require("zlib");                                                                                    // 2118
    var Url = Npm.require("url");                                                                                      // 2119
                                                                                                                       //
    var replicaNumber = Meteor.settings.replicaNumber || 0;                                                            // 2121
                                                                                                                       //
    var computeStagger = function computeStagger(n) {                                                                  // 2123
      // Compute a fraction in the range [0, 1) such that, for any natural number k, the values                        //
      // of computeStagger(n) for all n in [1, 2^k) are uniformly distributed between 0 and 1.                         //
      // The sequence looks like:                                                                                      //
      //   0, 1/2, 1/4, 3/4, 1/8, 3/8, 5/8, 7/8, 1/16, ...                                                             //
      //                                                                                                               //
      // We use this to determine how we'll stagger periodic events performed by this replica.                         //
      // Notice that this allows us to compute a stagger which is independent of the number of                         //
      // front-end replicas present; we can add more replicas to the end without affecting how the                     //
      // earlier ones schedule their events.                                                                           //
      var denom = 1;                                                                                                   // 2133
      while (denom <= n) {                                                                                             // 2134
        denom <<= 1;                                                                                                   // 2134
      }var num = n * 2 - denom + 1;                                                                                    // 2134
      return num / denom;                                                                                              // 2136
    };                                                                                                                 // 2137
                                                                                                                       //
    var stagger = computeStagger(replicaNumber);                                                                       // 2139
                                                                                                                       //
    SandstormDb.periodicCleanup = function (intervalMs, callback) {                                                    // 2141
      // Register a database cleanup function than should run periodically, roughly once every                         //
      // interval of the given length.                                                                                 //
      //                                                                                                               //
      // In a blackrock deployment with multiple front-ends, the frequency of the cleanup will be                      //
      // scaled appropriately on the assumption that more data is being generated demanding more                       //
      // frequent cleanups.                                                                                            //
                                                                                                                       //
      check(intervalMs, Number);                                                                                       // 2149
      check(callback, Function);                                                                                       // 2150
                                                                                                                       //
      if (intervalMs < 120000) {                                                                                       // 2152
        throw new Error("less than 2-minute cleanup interval seems too fast; " + "are you using the right units?");    // 2153
      }                                                                                                                // 2155
                                                                                                                       //
      // Schedule first cleanup to happen at the next intervalMs interval from the epoch, so that                      //
      // the schedule is independent of the exact startup time.                                                        //
      var first = intervalMs - Date.now() % intervalMs;                                                                // 2159
                                                                                                                       //
      // Stagger cleanups across replicas so that we don't have all replicas trying to clean the                       //
      // same data at the same time.                                                                                   //
      first += Math.floor(intervalMs * computeStagger(replicaNumber));                                                 // 2163
                                                                                                                       //
      // If the stagger put us more than an interval away from now, back up.                                           //
      if (first > intervalMs) first -= intervalMs;                                                                     // 2166
                                                                                                                       //
      Meteor.setTimeout(function () {                                                                                  // 2168
        callback();                                                                                                    // 2169
        Meteor.setInterval(callback, intervalMs);                                                                      // 2170
      }, first);                                                                                                       // 2171
    };                                                                                                                 // 2172
                                                                                                                       //
    // TODO(cleanup): Node 0.12 has a `gzipSync` but 0.10 (which Meteor still uses) does not.                          //
    var gzipSync = Meteor.wrapAsync(Zlib.gzip, Zlib);                                                                  // 2175
                                                                                                                       //
    var BufferSmallerThan = function BufferSmallerThan(limit) {                                                        // 2177
      return Match.Where(function (buf) {                                                                              // 2178
        check(buf, Buffer);                                                                                            // 2179
        return buf.length < limit;                                                                                     // 2180
      });                                                                                                              // 2181
    };                                                                                                                 // 2182
                                                                                                                       //
    var DatabaseId = Match.Where(function (s) {                                                                        // 2184
      check(s, String);                                                                                                // 2185
      return !!s.match(/^[a-zA-Z0-9_]+$/);                                                                             // 2186
    });                                                                                                                // 2187
                                                                                                                       //
    SandstormDb.prototype.addStaticAsset = function (metadata, content) {                                              // 2189
      // Add a new static asset to the database. If `content` is a string rather than a buffer, it                     //
      // will be automatically gzipped before storage; do not specify metadata.encoding in this case.                  //
                                                                                                                       //
      if (typeof content === "string" && !metadata.encoding) {                                                         // 2193
        content = gzipSync(new Buffer(content, "utf8"));                                                               // 2194
        metadata.encoding = "gzip";                                                                                    // 2195
      }                                                                                                                // 2196
                                                                                                                       //
      check(metadata, {                                                                                                // 2198
        mimeType: String,                                                                                              // 2199
        encoding: Match.Optional("gzip")                                                                               // 2200
      });                                                                                                              // 2198
      check(content, BufferSmallerThan(1 << 20));                                                                      // 2202
                                                                                                                       //
      // Validate content type.                                                                                        //
      metadata.mimeType = ContentType.format(ContentType.parse(metadata.mimeType));                                    // 2205
                                                                                                                       //
      var hasher = Crypto.createHash("sha256");                                                                        // 2207
      hasher.update(metadata.mimeType + "\n" + metadata.encoding + "\n", "utf8");                                      // 2208
      hasher.update(content);                                                                                          // 2209
      var hash = hasher.digest("base64");                                                                              // 2210
                                                                                                                       //
      var result = this.collections.staticAssets.findAndModify({                                                       // 2212
        query: { hash: hash, refcount: { $gte: 1 } },                                                                  // 2213
        update: { $inc: { refcount: 1 } },                                                                             // 2214
        fields: { _id: 1, refcount: 1 }                                                                                // 2215
      });                                                                                                              // 2212
                                                                                                                       //
      if (!result.ok) {                                                                                                // 2218
        throw new Error("Couldn't increment refcount of asset with hash " + hash);                                     // 2219
      }                                                                                                                // 2220
                                                                                                                       //
      var existing = result.value;                                                                                     // 2222
      if (existing) {                                                                                                  // 2223
        return existing._id;                                                                                           // 2224
      }                                                                                                                // 2225
                                                                                                                       //
      return this.collections.staticAssets.insert(_.extend({                                                           // 2227
        hash: hash,                                                                                                    // 2228
        content: content,                                                                                              // 2229
        refcount: 1                                                                                                    // 2230
      }, metadata));                                                                                                   // 2227
    };                                                                                                                 // 2232
                                                                                                                       //
    SandstormDb.prototype.refStaticAsset = function (id) {                                                             // 2234
      // Increment the refcount on an existing static asset. Returns the asset on success.                             //
      // If the asset does not exist, returns a falsey value.                                                          //
      //                                                                                                               //
      // You must call this BEFORE adding the new reference to the DB, in case of failure between                      //
      // the two calls. (This way, the failure case is a storage leak, which is probably not a big                     //
      // deal and can be fixed by GC, rather than a mysteriously missing asset.)                                       //
                                                                                                                       //
      check(id, String);                                                                                               // 2242
                                                                                                                       //
      var result = this.collections.staticAssets.findAndModify({                                                       // 2244
        query: { hash: hash },                                                                                         // 2245
        update: { $inc: { refcount: 1 } },                                                                             // 2246
        fields: { _id: 1, content: 1, mimeType: 1 }                                                                    // 2247
      });                                                                                                              // 2244
                                                                                                                       //
      if (!result.ok) {                                                                                                // 2250
        throw new Error("Couldn't increment refcount of asset with hash " + hash);                                     // 2251
      }                                                                                                                // 2252
                                                                                                                       //
      var existing = result.value;                                                                                     // 2254
      return existing;                                                                                                 // 2255
    };                                                                                                                 // 2256
                                                                                                                       //
    SandstormDb.prototype.unrefStaticAsset = function (id) {                                                           // 2258
      // Decrement refcount on a static asset and delete if it has reached zero.                                       //
      //                                                                                                               //
      // You must call this AFTER removing the reference from the DB, in case of failure between                       //
      // the two calls. (This way, the failure case is a storage leak, which is probably not a big                     //
      // deal and can be fixed by GC, rather than a mysteriously missing asset.)                                       //
                                                                                                                       //
      check(id, String);                                                                                               // 2265
                                                                                                                       //
      var result = this.collections.staticAssets.findAndModify({                                                       // 2267
        query: { _id: id },                                                                                            // 2268
        update: { $inc: { refcount: -1 } },                                                                            // 2269
        fields: { _id: 1, refcount: 1 },                                                                               // 2270
        "new": true                                                                                                    // 2271
      });                                                                                                              // 2267
                                                                                                                       //
      if (!result.ok) {                                                                                                // 2274
        throw new Error("Couldn't unref static asset " + id);                                                          // 2275
      }                                                                                                                // 2276
                                                                                                                       //
      var existing = result.value;                                                                                     // 2278
      if (!existing) {                                                                                                 // 2279
        console.error(new Error("unrefStaticAsset() called on asset that doesn't exist").stack);                       // 2280
      } else if (existing.refcount <= 0) {                                                                             // 2281
        this.collections.staticAssets.remove({ _id: existing._id });                                                   // 2282
      }                                                                                                                // 2283
    };                                                                                                                 // 2284
                                                                                                                       //
    SandstormDb.prototype.getStaticAsset = function (id) {                                                             // 2286
      // Get a static asset's mimeType, encoding, and raw content.                                                     //
                                                                                                                       //
      check(id, String);                                                                                               // 2289
                                                                                                                       //
      var asset = this.collections.staticAssets.findOne(id, { fields: { _id: 0, mimeType: 1, encoding: 1, content: 1 } });
      if (asset) {                                                                                                     // 2292
        // TODO(perf): Mongo converts buffers to something else. Figure out a way to avoid a copy                      //
        //   here.                                                                                                     //
        asset.content = new Buffer(asset.content);                                                                     // 2295
      }                                                                                                                // 2296
                                                                                                                       //
      return asset;                                                                                                    // 2298
    };                                                                                                                 // 2299
                                                                                                                       //
    SandstormDb.prototype.newAssetUpload = function (purpose) {                                                        // 2301
      check(purpose, Match.OneOf({ profilePicture: { userId: DatabaseId, identityId: DatabaseId } }, { loginLogo: {} }));
                                                                                                                       //
      return this.collections.assetUploadTokens.insert({                                                               // 2307
        purpose: purpose,                                                                                              // 2308
        expires: new Date(Date.now() + 300000) });                                                                     // 2309
    };                                                                                                                 // 2311
                                                                                                                       //
    // in 5 minutes                                                                                                    //
    SandstormDb.prototype.fulfillAssetUpload = function (id) {                                                         // 2313
      // Indicates that the given asset upload has completed. It will be removed and its purpose                       //
      // returned. If no matching upload exists, returns undefined.                                                    //
                                                                                                                       //
      check(id, String);                                                                                               // 2317
                                                                                                                       //
      var result = this.collections.assetUploadTokens.findAndModify({                                                  // 2319
        query: { _id: id },                                                                                            // 2320
        remove: true                                                                                                   // 2321
      });                                                                                                              // 2319
                                                                                                                       //
      if (!result.ok) {                                                                                                // 2324
        throw new Error("Failed to remove asset upload token");                                                        // 2325
      }                                                                                                                // 2326
                                                                                                                       //
      var upload = result.value;                                                                                       // 2328
                                                                                                                       //
      if (upload.expires.valueOf() < Date.now()) {                                                                     // 2330
        return undefined; // already expired                                                                           // 2331
      } else {                                                                                                         // 2332
          return upload.purpose;                                                                                       // 2333
        }                                                                                                              // 2334
    };                                                                                                                 // 2335
                                                                                                                       //
    SandstormDb.prototype.cleanupExpiredAssetUploads = function () {                                                   // 2337
      this.collections.assetUploadTokens.remove({ expires: { $lt: Date.now() } });                                     // 2338
    };                                                                                                                 // 2339
                                                                                                                       //
    // TODO(cleanup): lift this out of the package so it can share with the ones in async-helpers.js                   //
    var Future = Npm.require("fibers/future");                                                                         // 2342
    var promiseToFuture = function promiseToFuture(promise) {                                                          // 2343
      var result = new Future();                                                                                       // 2344
      promise.then(result["return"].bind(result), result["throw"].bind(result));                                       // 2345
      return result;                                                                                                   // 2346
    };                                                                                                                 // 2347
                                                                                                                       //
    var waitPromise = function waitPromise(promise) {                                                                  // 2349
      return promiseToFuture(promise).wait();                                                                          // 2350
    };                                                                                                                 // 2351
                                                                                                                       //
    SandstormDb.prototype.deleteGrains = function (query, backend, type) {                                             // 2353
      var _this9 = this;                                                                                               // 2353
                                                                                                                       //
      // Returns the number of grains deleted.                                                                         //
                                                                                                                       //
      check(type, Match.OneOf("grain", "demoGrain"));                                                                  // 2356
                                                                                                                       //
      var numDeleted = 0;                                                                                              // 2358
      this.collections.grains.find(query).forEach(function (grain) {                                                   // 2359
        waitPromise(backend.deleteGrain(grain._id, grain.userId));                                                     // 2360
        numDeleted += _this9.collections.grains.remove({ _id: grain._id });                                            // 2361
        _this9.removeApiTokens({                                                                                       // 2362
          grainId: grain._id,                                                                                          // 2363
          $or: [{ owner: { $exists: false } }, { owner: { webkey: null } }]                                            // 2364
        });                                                                                                            // 2362
                                                                                                                       //
        _this9.removeApiTokens({ "owner.grain.grainId": grain._id });                                                  // 2370
                                                                                                                       //
        _this9.collections.activitySubscriptions.remove({ grainId: grain._id });                                       // 2372
                                                                                                                       //
        if (grain.lastUsed) {                                                                                          // 2374
          _this9.collections.deleteStats.insert({                                                                      // 2375
            type: "grain", // Demo grains can never get here!                                                          // 2376
            lastActive: grain.lastUsed,                                                                                // 2377
            appId: grain.appId                                                                                         // 2378
          });                                                                                                          // 2375
        }                                                                                                              // 2380
                                                                                                                       //
        _this9.deleteUnusedPackages(grain.appId);                                                                      // 2382
                                                                                                                       //
        if (grain.size) {                                                                                              // 2384
          Meteor.users.update(grain.userId, { $inc: { storageUsage: -grain.size } });                                  // 2385
        }                                                                                                              // 2386
      });                                                                                                              // 2387
      return numDeleted;                                                                                               // 2388
    };                                                                                                                 // 2389
                                                                                                                       //
    SandstormDb.prototype.userGrainTitle = function (grainId, accountId, identityId) {                                 // 2391
      check(grainId, String);                                                                                          // 2392
      check(accountId, Match.OneOf(String, undefined, null));                                                          // 2393
      check(identityId, String);                                                                                       // 2394
                                                                                                                       //
      var grain = this.getGrain(grainId);                                                                              // 2396
      if (!grain) {                                                                                                    // 2397
        throw new Error("called userGrainTitle() for a grain that doesn't exist");                                     // 2398
      }                                                                                                                // 2399
                                                                                                                       //
      var title = grain.title;                                                                                         // 2401
      if (grain.userId !== accountId) {                                                                                // 2402
        var sharerToken = this.collections.apiTokens.findOne({                                                         // 2403
          grainId: grainId,                                                                                            // 2404
          "owner.user.identityId": identityId                                                                          // 2405
        }, {                                                                                                           // 2403
          sort: {                                                                                                      // 2407
            lastUsed: -1                                                                                               // 2408
          }                                                                                                            // 2407
        });                                                                                                            // 2406
        if (sharerToken) {                                                                                             // 2411
          title = sharerToken.owner.user.title;                                                                        // 2412
        } else {                                                                                                       // 2413
          title = "shared grain";                                                                                      // 2414
        }                                                                                                              // 2415
      }                                                                                                                // 2416
                                                                                                                       //
      return title;                                                                                                    // 2418
    };                                                                                                                 // 2419
                                                                                                                       //
    var packageCache = {};                                                                                             // 2421
    // Package info is immutable. Let's cache to save on mongo queries.                                                //
                                                                                                                       //
    SandstormDb.prototype.getPackage = function (packageId) {                                                          // 2424
      // Get the given package record. Since package info is immutable, cache the data in the server                   //
      // to reduce mongo query overhead, since it turns out we have to fetch specific packages a                       //
      // lot.                                                                                                          //
                                                                                                                       //
      if (packageId in packageCache) {                                                                                 // 2429
        return packageCache[packageId];                                                                                // 2430
      }                                                                                                                // 2431
                                                                                                                       //
      var pkg = this.collections.packages.findOne(packageId);                                                          // 2433
      if (pkg && pkg.status === "ready") {                                                                             // 2434
        packageCache[packageId] = pkg;                                                                                 // 2435
      }                                                                                                                // 2436
                                                                                                                       //
      return pkg;                                                                                                      // 2438
    };                                                                                                                 // 2439
                                                                                                                       //
    SandstormDb.prototype.deleteUnusedPackages = function (appId) {                                                    // 2441
      var _this10 = this;                                                                                              // 2441
                                                                                                                       //
      check(appId, String);                                                                                            // 2442
      this.collections.packages.find({ appId: appId }).forEach(function (pkg) {                                        // 2443
        // Mark package for possible deletion;                                                                         //
        _this10.collections.packages.update({ _id: pkg._id, status: "ready" }, { $set: { shouldCleanup: true } });     // 2445
      });                                                                                                              // 2446
    };                                                                                                                 // 2447
                                                                                                                       //
    SandstormDb.prototype.sendAppUpdateNotifications = function (appId, packageId, name, versionNumber, marketingVersion) {
      var _this11 = this;                                                                                              // 2450
                                                                                                                       //
      var actions = this.collections.userActions.find({ appId: appId, appVersion: { $lt: versionNumber } }, { fields: { userId: 1 } });
      actions.forEach(function (action) {                                                                              // 2453
        var userId = action.userId;                                                                                    // 2454
        var updater = {                                                                                                // 2455
          timestamp: new Date(),                                                                                       // 2456
          isUnread: true                                                                                               // 2457
        };                                                                                                             // 2455
        var inserter = _.extend({ userId: userId, appUpdates: {} }, updater);                                          // 2459
                                                                                                                       //
        // Set only the appId that we care about. Use mongo's dot notation to specify only a single                    //
        // field inside of an object to update                                                                         //
        inserter.appUpdates[appId] = updater["appUpdates." + appId] = {                                                // 2463
          marketingVersion: marketingVersion,                                                                          // 2464
          packageId: packageId,                                                                                        // 2465
          name: name,                                                                                                  // 2466
          version: versionNumber                                                                                       // 2467
        };                                                                                                             // 2463
                                                                                                                       //
        // We unfortunately cannot upsert because upserts can only have field equality conditions in                   //
        // the query. If we try to upsert, Mongo complaints that "$exists" isn't valid to store.                       //
        if (_this11.collections.notifications.update({ userId: userId, appUpdates: { $exists: true } }, { $set: updater }) == 0) {
          // Update failed; try an insert instead.                                                                     //
          _this11.collections.notifications.insert(inserter);                                                          // 2476
        }                                                                                                              // 2477
      });                                                                                                              // 2478
                                                                                                                       //
      this.collections.appIndex.update({ _id: appId }, { $set: { hasSentNotifications: true } });                      // 2480
                                                                                                                       //
      // In the case where we replaced a previous notification and that was the only reference to the                  //
      // package, we need to clean it up                                                                               //
      this.deleteUnusedPackages(appId);                                                                                // 2484
    };                                                                                                                 // 2485
                                                                                                                       //
    SandstormDb.prototype.sendReferralProgramNotification = function (userId) {                                        // 2487
      this.collections.notifications.upsert({                                                                          // 2488
        userId: userId,                                                                                                // 2489
        referral: true                                                                                                 // 2490
      }, {                                                                                                             // 2488
        userId: userId,                                                                                                // 2492
        referral: true,                                                                                                // 2493
        timestamp: new Date(),                                                                                         // 2494
        isUnread: true                                                                                                 // 2495
      });                                                                                                              // 2491
    };                                                                                                                 // 2497
                                                                                                                       //
    SandstormDb.prototype.upgradeGrains = function (appId, version, packageId, backend) {                              // 2499
      check(appId, String);                                                                                            // 2500
      check(version, Match.Integer);                                                                                   // 2501
      check(packageId, String);                                                                                        // 2502
                                                                                                                       //
      var selector = {                                                                                                 // 2504
        userId: Meteor.userId(),                                                                                       // 2505
        appId: appId,                                                                                                  // 2506
        appVersion: { $lte: version },                                                                                 // 2507
        packageId: { $ne: packageId }                                                                                  // 2508
      };                                                                                                               // 2504
                                                                                                                       //
      this.collections.grains.find(selector).forEach(function (grain) {                                                // 2511
        backend.shutdownGrain(grain._id, grain.userId);                                                                // 2512
      });                                                                                                              // 2513
                                                                                                                       //
      this.collections.grains.update(selector, {                                                                       // 2515
        $set: { appVersion: version, packageId: packageId, packageSalt: Random.secret() }                              // 2516
      }, { multi: true });                                                                                             // 2515
    };                                                                                                                 // 2518
                                                                                                                       //
    SandstormDb.prototype.startInstall = function (packageId, url, retryFailed, isAutoUpdated) {                       // 2520
      // Mark package for possible installation.                                                                       //
                                                                                                                       //
      var fields = {                                                                                                   // 2523
        status: "download",                                                                                            // 2524
        progress: 0,                                                                                                   // 2525
        url: url,                                                                                                      // 2526
        isAutoUpdated: !!isAutoUpdated                                                                                 // 2527
      };                                                                                                               // 2523
                                                                                                                       //
      if (retryFailed) {                                                                                               // 2530
        this.collections.packages.update({ _id: packageId, status: "failed" }, { $set: fields });                      // 2531
      } else {                                                                                                         // 2532
        try {                                                                                                          // 2533
          fields._id = packageId;                                                                                      // 2534
          this.collections.packages.insert(fields);                                                                    // 2535
        } catch (err) {                                                                                                // 2536
          console.error("Simultaneous startInstall()s?", err.stack);                                                   // 2537
        }                                                                                                              // 2538
      }                                                                                                                // 2539
    };                                                                                                                 // 2540
                                                                                                                       //
    var ValidKeyFingerprint = Match.Where(function (keyFingerprint) {                                                  // 2542
      check(keyFingerprint, String);                                                                                   // 2543
      return !!keyFingerprint.match(/^[0-9A-F]{40}$/);                                                                 // 2544
    });                                                                                                                // 2545
                                                                                                                       //
    SandstormDb.prototype.updateKeybaseProfileAsync = function (keyFingerprint) {                                      // 2547
      var _this12 = this;                                                                                              // 2547
                                                                                                                       //
      // Asynchronously fetch the given Keybase profile and populate the KeybaseProfiles collection.                   //
                                                                                                                       //
      check(keyFingerprint, ValidKeyFingerprint);                                                                      // 2550
                                                                                                                       //
      console.log("fetching keybase", keyFingerprint);                                                                 // 2552
                                                                                                                       //
      HTTP.get("https://keybase.io/_/api/1.0/user/lookup.json?key_fingerprint=" + keyFingerprint + "&fields=basics,profile,proofs_summary", {
        timeout: 5000                                                                                                  // 2557
      }, function (err, keybaseResponse) {                                                                             // 2556
        if (err) {                                                                                                     // 2559
          console.log("keybase lookup error:", err.stack);                                                             // 2560
          return;                                                                                                      // 2561
        }                                                                                                              // 2562
                                                                                                                       //
        if (!keybaseResponse.data) {                                                                                   // 2564
          console.log("keybase didn't return JSON? Headers:", keybaseResponse.headers);                                // 2565
          return;                                                                                                      // 2566
        }                                                                                                              // 2567
                                                                                                                       //
        var profile = (keybaseResponse.data.them || [])[0];                                                            // 2569
                                                                                                                       //
        if (profile) {                                                                                                 // 2571
          // jscs:disable requireCamelCaseOrUpperCaseIdentifiers                                                       //
          var record = {                                                                                               // 2573
            displayName: (profile.profile || {}).full_name,                                                            // 2574
            handle: (profile.basics || {}).username,                                                                   // 2575
            proofs: (profile.proofs_summary || {}).all || []                                                           // 2576
          };                                                                                                           // 2573
          // jscs:enable requireCamelCaseOrUpperCaseIdentifiers                                                        //
                                                                                                                       //
          record.proofs.forEach(function (proof) {                                                                     // 2580
            // Remove potentially Mongo-incompatible stuff. (Currently Keybase returns nothing that                    //
            // this would filter.)                                                                                     //
            for (var field in proof) {                                                                                 // 2583
              // Don't allow field names containing '.' or '$'. Also don't allow sub-objects mainly                    //
              // because I'm too lazy to check the field names recursively (and Keybase doesn't                        //
              // return any objects anyway).                                                                           //
              if (field.match(/[.$]/) || _typeof(proof[field]) === "object") {                                         // 2587
                delete proof[field];                                                                                   // 2588
              }                                                                                                        // 2589
            }                                                                                                          // 2590
                                                                                                                       //
            // Indicate not verified.                                                                                  //
            // TODO(security): Asynchronously verify proofs. Presumably we can borrow code from the                    //
            //   Keybase node-based CLI.                                                                               //
            proof.status = "unverified";                                                                               // 2595
          });                                                                                                          // 2596
                                                                                                                       //
          _this12.collections.keybaseProfiles.update(keyFingerprint, { $set: record }, { upsert: true });              // 2598
        } else {                                                                                                       // 2599
          // Keybase reports no match, so remove what we know of this user. We don't want to remove                    //
          // the item entirely from the cache as this will cause us to repeatedly re-fetch the data                    //
          // from Keybase.                                                                                             //
          //                                                                                                           //
          // TODO(someday): We could perhaps keep the proofs if we can still verify them directly,                     //
          //   but at present we don't have the ability to verify proofs.                                              //
          _this12.collections.keybaseProfiles.update(keyFingerprint, { $unset: { displayName: "", handle: "", proofs: "" } }, { upsert: true });
        }                                                                                                              // 2608
      });                                                                                                              // 2609
    };                                                                                                                 // 2610
                                                                                                                       //
    SandstormDb.prototype.deleteUnusedAccount = function (backend, identityId) {                                       // 2612
      // If there is an *unused* account that has `identityId` as a login identity, deletes it.                        //
                                                                                                                       //
      check(identityId, String);                                                                                       // 2615
      var account = this.collections.users.findOne({ "loginIdentities.id": identityId });                              // 2616
      if (account && account.loginIdentities.length == 1 && account.nonloginIdentities.length == 0 && !this.collections.grains.findOne({ userId: account._id }) && !this.collections.apiTokens.findOne({ accountId: account._id }) && (!account.plan || account.plan === "free") && !(account.payments && account.payments.id) && !this.collections.contacts.findOne({ ownerId: account._id })) {
        this.collections.users.remove({ _id: account._id });                                                           // 2625
        backend.deleteUser(account._id);                                                                               // 2626
      }                                                                                                                // 2627
    };                                                                                                                 // 2628
                                                                                                                       //
    Meteor.publish("keybaseProfile", function (keyFingerprint) {                                                       // 2630
      check(keyFingerprint, ValidKeyFingerprint);                                                                      // 2631
      var db = this.connection.sandstormDb;                                                                            // 2632
                                                                                                                       //
      var cursor = db.collections.keybaseProfiles.find(keyFingerprint);                                                // 2634
      if (cursor.count() === 0) {                                                                                      // 2635
        // Fire off async update.                                                                                      //
        db.updateKeybaseProfileAsync(keyFingerprint);                                                                  // 2637
      }                                                                                                                // 2638
                                                                                                                       //
      return cursor;                                                                                                   // 2640
    });                                                                                                                // 2641
                                                                                                                       //
    Meteor.publish("appIndex", function (appId) {                                                                      // 2643
      check(appId, String);                                                                                            // 2644
      var db = this.connection.sandstormDb;                                                                            // 2645
      var cursor = db.collections.appIndex.find({ _id: appId });                                                       // 2646
      return cursor;                                                                                                   // 2647
    });                                                                                                                // 2648
                                                                                                                       //
    Meteor.publish("userPackages", function () {                                                                       // 2650
      var _this13 = this;                                                                                              // 2650
                                                                                                                       //
      // Users should be able to see packages that are either:                                                         //
      // 1. referenced by one of their userActions                                                                     //
      // 2. referenced by one of their grains                                                                          //
      var db = this.connection.sandstormDb;                                                                            // 2654
                                                                                                                       //
      // Note that package information, once it is in the database, is static. There's no need to                      //
      // reactively subscribe to changes to a package since they don't change. It's also unecessary                    //
      // to reactively remove a package from the client side when it is removed on the server, or                      //
      // when the client stops using it, because the worst case is the client has a small amount                       //
      // of extra info on a no-longer-used package held in memory until they refresh Sandstorm.                        //
      // So, we implement this as a cache: the first time each package ID shows up among the user's                    //
      // stuff, we push the package info to the client, and then we never update it.                                   //
      //                                                                                                               //
      // Alternatively, we could subscribe to each individual package query, but this would waste                      //
      // lots of server-side resources watching for events that will never happen or don't matter.                     //
      var hasPackage = {};                                                                                             // 2666
      var refPackage = function refPackage(packageId) {                                                                // 2667
        // Ignore dev apps.                                                                                            //
        if (packageId.lastIndexOf("dev-", 0) === 0) return;                                                            // 2669
                                                                                                                       //
        if (!hasPackage[packageId]) {                                                                                  // 2671
          hasPackage[packageId] = true;                                                                                // 2672
          var pkg = db.getPackage(packageId);                                                                          // 2673
          if (pkg) {                                                                                                   // 2674
            _this13.added("packages", packageId, pkg);                                                                 // 2675
          } else {                                                                                                     // 2676
            console.error("shouldn't happen: missing package referenced by user's stuff:", packageId);                 // 2677
          }                                                                                                            // 2679
        }                                                                                                              // 2680
      };                                                                                                               // 2681
                                                                                                                       //
      // package source 1: packages referred to by actions                                                             //
      var actions = db.userActions(this.userId);                                                                       // 2684
      var actionsHandle = actions.observe({                                                                            // 2685
        added: function added(newAction) {                                                                             // 2686
          refPackage(newAction.packageId);                                                                             // 2687
        },                                                                                                             // 2688
        changed: function changed(newAction, oldAction) {                                                              // 2690
          refPackage(newAction.packageId);                                                                             // 2691
        }                                                                                                              // 2692
      });                                                                                                              // 2685
                                                                                                                       //
      // package source 2: packages referred to by grains directly                                                     //
      var grains = db.userGrains(this.userId, { includeTrash: true });                                                 // 2696
      var grainsHandle = grains.observe({                                                                              // 2697
        added: function added(newGrain) {                                                                              // 2698
          // Watch out: DevApp grains can lack a packageId.                                                            //
          if (newGrain.packageId) {                                                                                    // 2700
            refPackage(newGrain.packageId);                                                                            // 2701
          }                                                                                                            // 2702
        },                                                                                                             // 2703
        changed: function changed(newGrain, oldGrain) {                                                                // 2705
          // Watch out: DevApp grains can lack a packageId.                                                            //
          if (newGrain.packageId) {                                                                                    // 2707
            refPackage(newGrain.packageId);                                                                            // 2708
          }                                                                                                            // 2709
        }                                                                                                              // 2710
      });                                                                                                              // 2697
                                                                                                                       //
      this.onStop(function () {                                                                                        // 2713
        actionsHandle.stop();                                                                                          // 2714
        grainsHandle.stop();                                                                                           // 2715
      });                                                                                                              // 2716
                                                                                                                       //
      this.ready();                                                                                                    // 2718
    });                                                                                                                // 2719
  })();                                                                                                                // 2115
}                                                                                                                      // 2720
                                                                                                                       //
var processRawFeatureKey = function processRawFeatureKey(featureKey, renewalProblem) {                                 // 2722
  // Maps the raw data of a signed feature key to the desired "effective" feature key we should use                    //
  // to govern high-level behavior.                                                                                    //
  var processedFeatureKey = _.clone(featureKey);                                                                       // 2725
                                                                                                                       //
  if (renewalProblem) {                                                                                                // 2727
    processedFeatureKey.renewalProblem = renewalProblem;                                                               // 2728
  }                                                                                                                    // 2729
                                                                                                                       //
  // Hook for future extensibility.                                                                                    //
  return processedFeatureKey;                                                                                          // 2732
};                                                                                                                     // 2733
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 2735
  (function () {                                                                                                       // 2735
    var processFeatureKeyDoc = function processFeatureKeyDoc(doc) {                                                    // 2736
      if (!doc) return null;                                                                                           // 2737
      var buf = new Buffer(doc.value);                                                                                 // 2738
      // We use loadSignedFeatureKey from server/feature-key.js.  This should probably get refactored                  //
      // once we can use ES6 modules.                                                                                  //
      var rawFeatureKey = loadSignedFeatureKey(buf);                                                                   // 2741
      return processRawFeatureKey(rawFeatureKey, doc.renewalProblem);                                                  // 2742
    };                                                                                                                 // 2743
                                                                                                                       //
    SandstormDb.prototype.currentFeatureKey = function () {                                                            // 2745
      // Returns an object with all of the current signed feature key properties,                                      //
      // or null, if the feature key is missing or not correctly signed.                                               //
      var doc = this.collections.featureKey.findOne({ _id: "currentFeatureKey" });                                     // 2748
      return processFeatureKeyDoc(doc);                                                                                // 2749
    };                                                                                                                 // 2750
                                                                                                                       //
    SandstormDb.prototype.observeFeatureKey = function (callback) {                                                    // 2752
      // Calls `callback(currentFeatureKey())` whenever the feature key changes. Returns an observe                    //
      // handle (use .stop() to stop observing).                                                                       //
                                                                                                                       //
      return this.collections.featureKey.find({ _id: "currentFeatureKey" }).observe({                                  // 2756
        added: function added(doc) {                                                                                   // 2757
          callback(processFeatureKeyDoc(doc));                                                                         // 2758
        },                                                                                                             // 2759
        changed: function changed(newDoc, oldDoc) {                                                                    // 2761
          if (newDoc.value !== oldDoc.value) {                                                                         // 2762
            callback(processFeatureKeyDoc(newDoc));                                                                    // 2763
          }                                                                                                            // 2764
        },                                                                                                             // 2765
        removed: function removed() {                                                                                  // 2767
          callback(null);                                                                                              // 2768
        }                                                                                                              // 2769
      });                                                                                                              // 2756
    };                                                                                                                 // 2771
  })();                                                                                                                // 2735
} else {                                                                                                               // 2772
  SandstormDb.prototype.currentFeatureKey = function () {                                                              // 2773
    var featureKey = this.collections.featureKey.findOne({ _id: "currentFeatureKey" });                                // 2774
    return processRawFeatureKey(featureKey);                                                                           // 2775
  };                                                                                                                   // 2776
}                                                                                                                      // 2777
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 2779
  SandstormDb.prototype.deleteIdentity = function (identityId) {                                                       // 2780
    check(identityId, String);                                                                                         // 2781
                                                                                                                       //
    this.removeApiTokens({ "owner.user.identityId": identityId });                                                     // 2783
    this.collections.contacts.remove({ identityId: identityId });                                                      // 2784
    Meteor.users.remove({ _id: identityId });                                                                          // 2785
  };                                                                                                                   // 2786
                                                                                                                       //
  SandstormDb.prototype.deleteAccount = function (userId, backend) {                                                   // 2788
    check(userId, String);                                                                                             // 2789
                                                                                                                       //
    var _this = this;                                                                                                  // 2791
    var user = Meteor.users.findOne({ _id: userId });                                                                  // 2792
    this.deleteGrains({ userId: userId }, backend, "grain");                                                           // 2793
    this.collections.userActions.remove({ userId: userId });                                                           // 2794
    this.collections.notifications.remove({ userId: userId });                                                         // 2795
    user.loginIdentities.forEach(function (identity) {                                                                 // 2796
      if (Meteor.users.find({ $or: [{ "loginIdentities.id": identity.id }, { "nonloginIdentities.id": identity.id }] }).count() === 1) {
        // If this is the only account with the identity, then delete it                                               //
        _this.deleteIdentity(identity.id);                                                                             // 2802
      }                                                                                                                // 2803
    });                                                                                                                // 2804
    user.nonloginIdentities.forEach(function (identity) {                                                              // 2805
      if (Meteor.users.find({ $or: [{ "loginIdentities.id": identity.id }, { "nonloginIdentities.id": identity.id }] }).count() === 1) {
        // If this is the only account with the identity, then delete it                                               //
        _this.deleteIdentity(identity.id);                                                                             // 2811
      }                                                                                                                // 2812
    });                                                                                                                // 2813
    this.collections.contacts.remove({ ownerId: userId });                                                             // 2814
    backend.deleteUser(userId);                                                                                        // 2815
    Meteor.users.remove({ _id: userId });                                                                              // 2816
  };                                                                                                                   // 2817
}                                                                                                                      // 2818
                                                                                                                       //
Meteor.methods({                                                                                                       // 2820
  addUserActions: function addUserActions(packageId) {                                                                 // 2821
    check(packageId, String);                                                                                          // 2822
    if (!this.userId || !Meteor.user().loginIdentities || !isSignedUpOrDemo()) {                                       // 2823
      throw new Meteor.Exception(403, "Must be logged in as a non-guest to add app actions.");                         // 2824
    }                                                                                                                  // 2825
                                                                                                                       //
    if (this.isSimulation) {                                                                                           // 2827
      // TODO(cleanup): Appdemo code relies on this being simulated client-side but we don't have                      //
      //   a proper DB object to use.                                                                                  //
      new SandstormDb().addUserActions(this.userId, packageId, true);                                                  // 2830
    } else {                                                                                                           // 2831
      this.connection.sandstormDb.addUserActions(this.userId, packageId);                                              // 2832
    }                                                                                                                  // 2833
  },                                                                                                                   // 2834
  removeUserAction: function removeUserAction(actionId) {                                                              // 2836
    check(actionId, String);                                                                                           // 2837
    if (this.isSimulation) {                                                                                           // 2838
      UserActions.remove({ _id: actionId });                                                                           // 2839
    } else {                                                                                                           // 2840
      if (this.userId) {                                                                                               // 2841
        var result = this.connection.sandstormDb.collections.userActions.findAndModify({                               // 2842
          query: { _id: actionId, userId: this.userId },                                                               // 2843
          remove: true                                                                                                 // 2844
        });                                                                                                            // 2842
                                                                                                                       //
        if (!result.ok) {                                                                                              // 2847
          throw new Error("Couldn't remove user action " + actionId);                                                  // 2848
        }                                                                                                              // 2849
                                                                                                                       //
        var action = result.value;                                                                                     // 2851
        if (action) {                                                                                                  // 2852
          this.connection.sandstormDb.deleteUnusedPackages(action.appId);                                              // 2853
        }                                                                                                              // 2854
      }                                                                                                                // 2855
    }                                                                                                                  // 2856
  }                                                                                                                    // 2857
});                                                                                                                    // 2820
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"profile.js":["babel-runtime/helpers/typeof",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/sandstorm-db/profile.js                                                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});                          //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var makeIdenticon = void 0;                                                                                            // 17
var httpProtocol = void 0;                                                                                             // 18
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 20
  SandstormDb.ensureSubscriberHasIdentity = function (publishHandler, identityId) {                                    // 21
    // Helper for publish functions that need to restrict access based on whether the subscriber                       //
    // has a given identity linked. Automatically stops the subscription if the user loses the                         //
    // identity. Returns a boolean indicating whether the user initially has the identity.                             //
                                                                                                                       //
    var userId = publishHandler.userId;                                                                                // 26
    if (userId === identityId) {                                                                                       // 27
      return true;                                                                                                     // 28
    } else {                                                                                                           // 29
      var _ret = function () {                                                                                         // 29
        var hasIdentityCursor = Meteor.users.find({                                                                    // 30
          $or: [{                                                                                                      // 31
            _id: userId,                                                                                               // 33
            "loginIdentities.id": identityId                                                                           // 34
          }, {                                                                                                         // 32
            _id: userId,                                                                                               // 37
            "nonloginIdentities.id": identityId                                                                        // 38
          }]                                                                                                           // 36
        });                                                                                                            // 30
        if (hasIdentityCursor.count() == 0) {                                                                          // 42
          publishHandler.stop();                                                                                       // 43
          return {                                                                                                     // 44
            v: false                                                                                                   // 44
          };                                                                                                           // 44
        }                                                                                                              // 45
                                                                                                                       //
        var handle = hasIdentityCursor.observe({ removed: function removed() {                                         // 47
            publishHandler.stop();                                                                                     // 47
          } });                                                                                                        // 47
                                                                                                                       //
        publishHandler.onStop(function () {                                                                            // 49
          handle.stop();                                                                                               // 49
        });                                                                                                            // 49
                                                                                                                       //
        return {                                                                                                       // 51
          v: true                                                                                                      // 51
        };                                                                                                             // 51
      }();                                                                                                             // 29
                                                                                                                       //
      if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                     // 29
    }                                                                                                                  // 52
  };                                                                                                                   // 53
                                                                                                                       //
  Meteor.publish("identityProfile", function (identityId) {                                                            // 55
    check(identityId, String);                                                                                         // 56
    if (!SandstormDb.ensureSubscriberHasIdentity(this, identityId)) return;                                            // 57
                                                                                                                       //
    return Meteor.users.find({ _id: identityId }, { fields: {                                                          // 59
        profile: 1,                                                                                                    // 61
        unverifiedEmail: 1,                                                                                            // 62
        expires: 1,                                                                                                    // 63
        createdAt: 1,                                                                                                  // 64
                                                                                                                       //
        "services.dev.name": 1,                                                                                        // 66
                                                                                                                       //
        "services.google.id": 1,                                                                                       // 68
        "services.google.email": 1,                                                                                    // 69
        "services.google.verified_email": 1,                                                                           // 70
        "services.google.name": 1,                                                                                     // 71
        "services.google.picture": 1,                                                                                  // 72
        "services.google.gender": 1,                                                                                   // 73
        "services.google.hd": 1,                                                                                       // 74
                                                                                                                       //
        "services.github.id": 1,                                                                                       // 76
        "services.github.email": 1,                                                                                    // 77
        "services.github.emails": 1,                                                                                   // 78
        "services.github.username": 1,                                                                                 // 79
                                                                                                                       //
        "services.email.email": 1,                                                                                     // 81
                                                                                                                       //
        "services.ldap.id": 1,                                                                                         // 83
        "services.ldap.username": 1,                                                                                   // 84
        "services.ldap.rawAttrs": 1,                                                                                   // 85
                                                                                                                       //
        "services.saml.id": 1,                                                                                         // 87
        "services.saml.email": 1,                                                                                      // 88
        "services.saml.displayName": 1                                                                                 // 89
      }                                                                                                                // 60
    });                                                                                                                // 60
  }), Meteor.publish("accountIdentities", function () {                                                                // 92
    // Maybe this should be folded into the "credentials" subscription?                                                //
                                                                                                                       //
    if (!this.userId) return [];                                                                                       // 97
                                                                                                                       //
    return Meteor.users.find({ _id: this.userId }, { fields: {                                                         // 99
        profile: 1,                                                                                                    // 102
        verifiedEmail: 1,                                                                                              // 103
        loginIdentities: 1,                                                                                            // 104
        nonloginIdentities: 1,                                                                                         // 105
        expires: 1,                                                                                                    // 106
        primaryEmail: 1                                                                                                // 107
      } });                                                                                                            // 101
  });                                                                                                                  // 109
                                                                                                                       //
  makeIdenticon = function makeIdenticon(id) {                                                                         // 111
    var hash = id.slice(0, 32);                                                                                        // 112
    return httpProtocol + "//" + makeWildcardHost("static") + "/identicon/" + hash + "?s=256";                         // 113
  };                                                                                                                   // 114
                                                                                                                       //
  var Url = Npm.require("url");                                                                                        // 116
  httpProtocol = Url.parse(process.env.ROOT_URL).protocol;                                                             // 117
} else {                                                                                                               // 118
  (function () {                                                                                                       // 118
    var identiconCache = {};                                                                                           // 119
                                                                                                                       //
    makeIdenticon = function makeIdenticon(id) {                                                                       // 121
      // Given a cryptographic hash as input, generate an identicon. We always use the user's                          //
      // identity ID as the input hash (the same thing passed to apps as the user ID).                                 //
                                                                                                                       //
      // Pass to identicon.js exactly the hash that we'd pass to apps as X-Sandstorm-User-Id, so                       //
      // that apps can themselves use identicon.js to produce consistent identicons. As it turns out                   //
      // identicon.js doesn't use the second half of the hash even if we provide it, but slice it                      //
      // anyway to be safe.                                                                                            //
      var hash = id.slice(0, 32);                                                                                      // 129
                                                                                                                       //
      if (hash in identiconCache) {                                                                                    // 131
        return identiconCache[hash];                                                                                   // 132
      }                                                                                                                // 133
                                                                                                                       //
      // Unfortunately, Github's algorithm uses MD5. Whatever, we don't expect these to be secure.                     //
      var data = new Identicon(hash, 512).toString();                                                                  // 136
      var result = "data:image/svg+xml," + encodeURIComponent(data);                                                   // 137
      identiconCache[hash] = result;                                                                                   // 138
      return result;                                                                                                   // 139
    };                                                                                                                 // 140
                                                                                                                       //
    httpProtocol = window.location.protocol;                                                                           // 142
  })();                                                                                                                // 118
}                                                                                                                      // 143
                                                                                                                       //
var GENDERS = { male: "male", female: "female", neutral: "neutral", robot: "robot" };                                  // 145
                                                                                                                       //
function staticAssetUrl(id, staticHost) {                                                                              // 147
  if (id) {                                                                                                            // 148
    return staticHost + "/" + id;                                                                                      // 149
  } else {                                                                                                             // 150
    return undefined;                                                                                                  // 151
  }                                                                                                                    // 152
}                                                                                                                      // 153
                                                                                                                       //
function filterHandle(handle) {                                                                                        // 155
  // Convert disallowed letters into underscores, but no more than one underscore in a row.                            //
  return handle && handle.toLowerCase().split(/[^a-z0-9_]+/g).join("_");                                               // 157
}                                                                                                                      // 158
                                                                                                                       //
function emailToHandle(email) {                                                                                        // 160
  // Turn an email address into a handle.                                                                              //
                                                                                                                       //
  if (!email) return undefined;                                                                                        // 163
                                                                                                                       //
  // Use the stuff before the @. Ignore stuff after '+' because it's commonly used for filters                         //
  // on the same account.                                                                                              //
  var parts = email.split("@");                                                                                        // 167
  var base = filterHandle(parts[0].split("+")[0]);                                                                     // 168
                                                                                                                       //
  var domain = (parts[1] || "").split(".");                                                                            // 170
  if (domain[domain.length - 1] === "name") {                                                                          // 171
    // Oh, a .name domain. Let's use                                                                                   //
    base = filterHandle(domain.slice(0, domain.length - 1).join("."));                                                 // 173
  } else if (_.contains(["me", "self", "contact", "admin", "administrator", "root", "info", "sandstorm", "sandstormio", "inbox", "indiegogo", "mail", "email"], base)) {
    // This is probably an address at a vanity domain. Use the domain itself as the handle.                            //
    base = filterHandle(domain[0]);                                                                                    // 181
  }                                                                                                                    // 182
                                                                                                                       //
  return filterHandle(base);                                                                                           // 184
}                                                                                                                      // 185
                                                                                                                       //
SandstormDb.fillInProfileDefaults = function (user) {                                                                  // 187
  var profile = user.profile;                                                                                          // 188
  if (profile.service === "github") {                                                                                  // 189
    profile.name = profile.name || user.services.github.username || "Name Unknown";                                    // 190
    profile.handle = profile.handle || filterHandle(user.services.github.username) || filterHandle(profile.name);      // 191
  } else if (profile.service === "google") {                                                                           // 193
    profile.name = profile.name || user.services.google.name || "Name Unknown";                                        // 194
    profile.handle = profile.handle || emailToHandle(user.services.google.email) || filterHandle(profile.name);        // 195
    profile.pronoun = profile.pronoun || GENDERS[user.services.google.gender] || "neutral";                            // 197
  } else if (profile.service === "email") {                                                                            // 198
    var email = user.services.email.email;                                                                             // 199
    profile.name = profile.name || emailToHandle(email);                                                               // 200
    profile.handle = profile.handle || emailToHandle(email);                                                           // 201
  } else if (profile.service === "dev") {                                                                              // 202
    var lowerCaseName = user.services.dev.name.split(" ")[0].toLowerCase();                                            // 203
    profile.name = profile.name || user.services.dev.name;                                                             // 204
    profile.handle = profile.handle || filterHandle(lowerCaseName);                                                    // 205
    profile.pronoun = profile.pronoun || (_.contains(["alice", "carol", "eve"], lowerCaseName) ? "female" : _.contains(["bob", "dave"], lowerCaseName) ? "male" : "neutral");
  } else if (profile.service === "demo") {                                                                             // 209
    profile.name = profile.name || "Demo User";                                                                        // 210
    profile.handle = profile.handle || "demo";                                                                         // 211
  } else if (profile.service === "ldap") {                                                                             // 212
    var setting = Settings.findOne({ _id: "ldapNameField" });                                                          // 213
    var key = setting ? setting.value : "";                                                                            // 214
    profile.handle = profile.handle || user.services.ldap.username;                                                    // 215
    profile.name = profile.name || user.services.ldap.rawAttrs[key] || profile.handle;                                 // 216
  } else if (profile.service === "saml") {                                                                             // 217
    profile.handle = profile.handle || emailToHandle(user.services.saml.email);                                        // 218
    profile.name = profile.name || user.services.saml.displayName || profile.handle;                                   // 219
  } else {                                                                                                             // 220
    throw new Error("unrecognized identity service: ", profile.service);                                               // 221
  }                                                                                                                    // 222
                                                                                                                       //
  profile.pronoun = profile.pronoun || "neutral";                                                                      // 224
};                                                                                                                     // 225
                                                                                                                       //
SandstormDb.fillInIntrinsicName = function (user) {                                                                    // 227
  var profile = user.profile;                                                                                          // 228
  if (profile.service === "github") {                                                                                  // 229
    profile.intrinsicName = user.services.github.username;                                                             // 230
  } else if (profile.service === "google") {                                                                           // 231
    profile.intrinsicName = user.services.google.name;                                                                 // 232
    user.privateIntrinsicName = user.services.google.email;                                                            // 233
  } else if (profile.service === "email") {                                                                            // 234
    profile.intrinsicName = user.services.email.email;                                                                 // 235
  } else if (profile.service === "dev") {                                                                              // 236
    profile.intrinsicName = user.services.dev.name;                                                                    // 237
  } else if (profile.service === "demo") {                                                                             // 238
    profile.intrinsicName = "demo on " + user.createdAt.toISOString().substring(0, 10);                                // 239
  } else if (profile.service === "ldap") {                                                                             // 240
    profile.intrinsicName = user.services.ldap.username;                                                               // 241
  } else if (profile.service === "saml") {                                                                             // 242
    profile.intrinsicName = user.services.saml.id;                                                                     // 243
  } else {                                                                                                             // 244
    throw new Error("unrecognized identity service: ", profile.service);                                               // 245
  }                                                                                                                    // 246
};                                                                                                                     // 247
                                                                                                                       //
SandstormDb.fillInLoginId = function (identity) {                                                                      // 249
  var service = identity.profile.service;                                                                              // 250
  identity.loginId = Accounts.identityServices[service].getLoginId(identity);                                          // 251
};                                                                                                                     // 252
                                                                                                                       //
SandstormDb.getVerifiedEmails = function (identity) {                                                                  // 254
  if (identity.services.google && identity.services.google.email && identity.services.google.verified_email) {         // 255
    // jscs:ignore requireCamelCaseOrUpperCaseIdentifiers                                                              //
    return [{ email: identity.services.google.email, primary: true }];                                                 // 257
  } else if (identity.services.email) {                                                                                // 258
    return [{ email: identity.services.email.email, primary: true }];                                                  // 259
  } else if (identity.services.github && identity.services.github.emails) {                                            // 260
    return _.chain(identity.services.github.emails).filter(function (email) {                                          // 261
      return email.verified;                                                                                           // 262
    }).map(function (email) {                                                                                          // 262
      return _.pick(email, "email", "primary");                                                                        // 263
    }).value();                                                                                                        // 263
  } else if (identity.services.ldap) {                                                                                 // 265
    // TODO(cleanup): don't create a new SandstormDb here, make this non-static                                        //
    var email = identity.services.ldap.rawAttrs[new SandstormDb().getLdapEmailField()];                                // 267
    if (email) {                                                                                                       // 268
      return [{ email: email, primary: true }];                                                                        // 269
    }                                                                                                                  // 270
  } else if (identity.services.saml && identity.services.saml.email) {                                                 // 271
    return [{ email: identity.services.saml.email, primary: true }];                                                   // 272
  }                                                                                                                    // 273
                                                                                                                       //
  return [];                                                                                                           // 275
};                                                                                                                     // 276
                                                                                                                       //
SandstormDb.prototype.findIdentitiesByEmail = function (email) {                                                       // 278
  // Returns an array of identities which have the given email address as one of their verified                        //
  // addresses.                                                                                                        //
                                                                                                                       //
  check(email, String);                                                                                                // 282
                                                                                                                       //
  return Meteor.users.find({ $or: [{ "services.google.email": email }, { "services.email.email": email }, { "services.github.emails.email": email }, { "services.saml.email": email }] }).fetch().filter(function (identity) {
    // Verify that the email is verified, since our query doesn't technically do that.                                 //
    return !!_findWhere(SandstormDb.getVerifiedEmails(identity), { email: email });                                    // 291
  });                                                                                                                  // 292
};                                                                                                                     // 293
                                                                                                                       //
SandstormDb.prototype.findAccountsByEmail = function (email) {                                                         // 295
  var identityIds = _.pluck(this.findIdentitiesByEmail(email), "_id");                                                 // 296
  return Meteor.users.find({ $or: [{ "loginIdentities.id": { $in: identityIds } }, { "nonloginIdentities.id": { $in: identityIds } }] }).fetch();
};                                                                                                                     // 301
                                                                                                                       //
SandstormDb.fillInPictureUrl = function (user) {                                                                       // 303
  var staticHost = httpProtocol + "//" + makeWildcardHost("static");                                                   // 304
  user.profile.pictureUrl = staticAssetUrl(user.profile.picture, staticHost) || makeIdenticon(user._id);               // 305
};                                                                                                                     // 307
                                                                                                                       //
SandstormDb.getUserIdentityIds = function (user) {                                                                     // 309
  // Given an account user object, returns an array containing the ID of each identity linked to the                   //
  // account. Always returns the most recently added login identity first.                                             //
  if (user && user.loginIdentities) {                                                                                  // 312
    return _.pluck(user.nonloginIdentities.concat(user.loginIdentities), "id").reverse();                              // 313
  } else {                                                                                                             // 314
    return [];                                                                                                         // 315
  }                                                                                                                    // 316
};                                                                                                                     // 317
                                                                                                                       //
SandstormDb.getUserEmails = function (user) {                                                                          // 319
  // Given a user object, returns an array containing all email addresses associated with that user.                   //
  // Each entry in the array is an object of the form:                                                                 //
  //     `{email: String, verified: Bool, primary: Optional(Bool)}`                                                    //
  //                                                                                                                   //
  // At most one entry in the result has `primary = true`.                                                             //
  //                                                                                                                   //
  // TODO(cleanup): This actually does need to query the database to fetch profile information                         //
  //   for linked identities, so it probably makes more sense for it to be a non-static method                         //
  //   on SandstormDb.                                                                                                 //
                                                                                                                       //
  var identityIds = SandstormDb.getUserIdentityIds(user);                                                              // 330
  var verifiedEmails = {};                                                                                             // 331
  var unverifiedEmails = {};                                                                                           // 332
                                                                                                                       //
  identityIds.forEach(function (id) {                                                                                  // 334
    var identity = Meteor.users.findOne({ _id: id });                                                                  // 335
    if (identity && identity.services) {                                                                               // 336
      SandstormDb.getVerifiedEmails(identity).forEach(function (verifiedEmail) {                                       // 337
        if (verifiedEmail) {                                                                                           // 338
          verifiedEmails[verifiedEmail.email] = true;                                                                  // 339
        }                                                                                                              // 340
      });                                                                                                              // 341
    }                                                                                                                  // 342
                                                                                                                       //
    if (identity && identity.unverifiedEmail) {                                                                        // 344
      unverifiedEmails[identity.unverifiedEmail] = true;                                                               // 345
    }                                                                                                                  // 346
  });                                                                                                                  // 347
                                                                                                                       //
  var result = [];                                                                                                     // 349
  _.keys(verifiedEmails).map(function (email) {                                                                        // 350
    result.push({ email: email,                                                                                        // 351
      verified: true,                                                                                                  // 352
      primary: email === user.primaryEmail });                                                                         // 353
  });                                                                                                                  // 354
                                                                                                                       //
  _.keys(unverifiedEmails).map(function (email) {                                                                      // 356
    if (!(email in verifiedEmails)) {                                                                                  // 357
      result.push({ email: email, verified: false });                                                                  // 357
    }                                                                                                                  // 357
  });                                                                                                                  // 358
                                                                                                                       //
  // If `user.primaryEmail` is not among the verified emails, mark the first as primary.                               //
  if (!(user.primaryEmail in verifiedEmails) && result.length > 0) {                                                   // 361
    result[0].primary = true;                                                                                          // 362
  }                                                                                                                    // 363
                                                                                                                       //
  return result;                                                                                                       // 365
};                                                                                                                     // 366
                                                                                                                       //
SandstormDb.prototype.addContact = function addContact(ownerId, identityId) {                                          // 368
  check(ownerId, String);                                                                                              // 369
  check(identityId, String);                                                                                           // 370
  var profile = this.getIdentity(identityId).profile;                                                                  // 371
  this.collections.contacts.upsert({ ownerId: ownerId, identityId: identityId }, {                                     // 372
    ownerId: ownerId,                                                                                                  // 373
    petname: profile && profile.name,                                                                                  // 374
    created: new Date(),                                                                                               // 375
    identityId: identityId                                                                                             // 376
  });                                                                                                                  // 372
};                                                                                                                     // 378
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]}}}},{"extensions":[".js",".json"]});
require("./node_modules/meteor/sandstorm-db/db.js");
require("./node_modules/meteor/sandstorm-db/profile.js");

/* Exports */
if (typeof Package === 'undefined') Package = {};
(function (pkg, symbols) {
  for (var s in symbols)
    (s in pkg) || (pkg[s] = symbols[s]);
})(Package['sandstorm-db'] = {}, {
  SandstormDb: SandstormDb
});

})();

//# sourceMappingURL=sandstorm-db.js.map
